package no.item.ntnu.arctis.examples.cityguide.cityguideserver;

import no.ntnu.item.arctis.runtime.IStateMachine;
import no.ntnu.item.arctis.runtime.Runtime;
import no.ntnu.item.arctis.runtime.Register;
import no.ntnu.item.arctis.runtime.IRegister;
import no.ntnu.item.arctis.runtime.Scheduler;

public class MyRuntime extends Runtime {

	private MyRuntime(IRegister register) {
		super(register);
	}

    public static Runtime create() {
        MyRuntime runtime = new MyRuntime(new Register());
        return runtime;
    }

	protected IStateMachine createDefaultStateMachine(Scheduler scheduler) {
		return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.ComponentSM(scheduler, null, null);
	}

	protected IStateMachine createSession(String signalID, Scheduler scheduler, String sessionID, String parentSessionID) {
        if("_c2_c3_GroupChat_Service_start".equals(signalID)) {
            return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.GroupChatServiceSM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c2_IM_Service_start".equals(signalID)) {
		    return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.IMServiceSM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c0_Group_Positioning_Service_register".equals(signalID)) {
		    return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.GroupPositioningServiceSM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c1_Login_Service_start".equals(signalID)) {
		    return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.LoginServiceSM(scheduler, sessionID, parentSessionID);
        } else if("_c1_c0_Location_Service_Proxy_start".equals(signalID)) {
		    return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.LocationServiceProxySM(scheduler, sessionID, parentSessionID);
        } else if("_c1_City_Guide_Service_userLoggedIn".equals(signalID)) {
		    return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.CityGuideServiceSM(scheduler, sessionID, parentSessionID);
        } else if("_c1_c2_Location_Aware_Quiz_Service_Proxy_start".equals(signalID)) {
		    return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.LocationAwareQuizServiceProxySM(scheduler, sessionID, parentSessionID);
        } else if("_c1_c3_Block_Address_Service_Proxy_start".equals(signalID)) {
		    return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.Block_AddressServiceProxySM(scheduler, sessionID, parentSessionID);
        } else if("_c1_c1_MyAddress_Service_Proxy_start".equals(signalID)) {
		    return new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.MyAddressServiceProxySM(scheduler, sessionID, parentSessionID);
        }
        return null;
    }

	protected boolean createsSession(String signalID) {
        if("_c2_c3_GroupChat_Service_start".equals(signalID)) {
            return true;
        } else if("_c2_c2_IM_Service_start".equals(signalID)) {
            return true;
        } else if("_c2_c0_Group_Positioning_Service_register".equals(signalID)) {
            return true;
        } else if("_c2_c1_Login_Service_start".equals(signalID)) {
            return true;
        } else if("_c1_c0_Location_Service_Proxy_start".equals(signalID)) {
            return true;
        } else if("_c1_City_Guide_Service_userLoggedIn".equals(signalID)) {
            return true;
        } else if("_c1_c2_Location_Aware_Quiz_Service_Proxy_start".equals(signalID)) {
            return true;
        } else if("_c1_c3_Block_Address_Service_Proxy_start".equals(signalID)) {
            return true;
        } else if("_c1_c1_MyAddress_Service_Proxy_start".equals(signalID)) {
            return true;
        }
        return false;
    }
}
