package no.item.ntnu.arctis.examples.cityguide.groupmanager;


import java.io.File;
import java.util.HashMap;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import no.ntnu.item.arctis.library.objects.user.Group;
import no.ntnu.item.arctis.library.objects.user.Player;
import no.tellu.common.actorframe.ActorSM;
import no.tellu.common.javaframe.ActorAddress;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;


import com.thoughtworks.xstream.XStream;

public class LoadUserConfiguration {

	private ActorSM asm;
	private Vector<Group> groups;
	private Vector<Player> players;
	private HashMap<String, Player> playerHash;
	
	private String configFileName= "config/userConfig3.xml";

	
	public LoadUserConfiguration(){
		super();
		this.playerHash = new HashMap<String,Player>();
		this.players = loadPlayersFromXMLFile();
		this.groups = loadGroupsFromXMLFile();
	}
	
	public LoadUserConfiguration(ActorSM asm){
		super();
		this.asm = asm;
		this.playerHash = new HashMap<String,Player>();
		this.players = loadPlayersFromXMLFile();
		this.groups = loadGroupsFromXMLFile();
	}
	
	public void addPlayerToGame(Player p){
		players.add(p);
		addPlayerNodeToXMLFile(p);
		for(int i=0; i<p.getGroups().size();i++){
			for(int j=0;j<groups.size();j++){
				if(p.getGroups().get(i)== groups.get(j)){
					groups.get(j).addPlayer(p);
				}
			}
		}
	}
	public void updatePlayerSettings(Player p,String oldUserName){
		for (int i = 0; i < players.size(); i++) {
			if(players.elementAt(i).getUserName().equals(oldUserName)){
				String newName = p.getUserName();
				players.set(i, p);
				p.setUserName(oldUserName);
				deletePlayerInXMLFile(p);
				p.setUserName(newName);
				addPlayerNodeToXMLFile(p);
				break;
			}
		}
	}
	public void updatePlayerSettings(Player p){
		for (int i = 0; i < players.size(); i++) {
			if(players.elementAt(i).getUserName().equals(p.getUserName())){
				players.set(i, p);
				deletePlayerInXMLFile(p);
				addPlayerNodeToXMLFile(p);
				break;
			}
		}
	}
	
	public void deletePlayer(Player p){
		for (int i = 0; i < players.size(); i++) {
			if(players.elementAt(i).getUserName().equals(p.getUserName())){
				players.remove(i);
				deletePlayerInXMLFile(p);
				break;
			}
		}
	}
	public void addGroupToGame(Group g){
		groups.add(g);
		addGroupNodeToXMLFile(g);
		for (int i = 0; i < g.getPlayers().size(); i++) {
			g.getPlayers().elementAt(i).getGroups().add(g);
		}
	}
	public void updateGroupSettings(Group g,String oldName){
		for (int i = 0; i < groups.size(); i++) {
			if(groups.elementAt(i).getGroupName().equals(oldName)){
				groups.set(i,g);
				String newName = g.getGroupName();
				g.setGroupName(oldName);
				deleteGroupInXMLFile(g);
				g.setGroupName(newName);
				addGroupNodeToXMLFile(g);
				break;
			}
		}
	}
	public void deleteGroup(Group g){
		for (int i = 0; i < groups.size(); i++) {
			if(groups.elementAt(i).getGroupName().equals(g.getGroupName())){
				groups.remove(i);
				deleteGroupInXMLFile(g);
			}
		}
	}
	
	/*
	public void updatePlayer(ActorAddress actorAddress){
		for(Group ga:this.getGroups()){
			System.out.println("groups: "+ ga.getGroupName()+ga.getActorAddress());
			Vector<Player> plrs = ga.getPlayers();
			for(Player pa: plrs){
				System.out.println("Players: "+pa.getUserName());
				if(pa.getActorAddress() == null && !(ga.getActorAddress() == null)){
					int index_pa = ga.getPlayers().indexOf(pa);
					int index_ga = this.getGroups().indexOf(ga);
					pa.setActorAddress(actorAddress);
					System.out.println("This ActorAddress set to: "+actorAddress);
					pa.setLocation("NTNU Glshaugen");
					pa.setStatus("Online");
					ga.getPlayers().set(index_pa, pa); // replace the old ta with new one at the same index
					this.getGroups().set(index_ga, ga);
					break;
				}
			}
		}
		// For debuging purpose ... printing treasure agents having not null actor address
		//printNotNullActorAddressPAs();
	}
	*/
	
	/*
	public void updateGroup(ActorAddress actorAddress){
		for(Group ga:this.getGroups()){
			if(ga.getActorAddress() == null){
				int index = this.getGroups().indexOf(ga);
				ga.setActorAddress(actorAddress);
				this.getGroups().set(index, ga); // replace the old ta with new one at the same index
				
				// send group information to ConfigurationAgent
				asm.sendMessage(new SendGroupsToConfigurationAgent(ga), new ActorAddress("/configurationAgent","ConfigurationAgent"));
				
				break;
			}
		}
		// For debuging purpose ... printing treasure agents having not null actor address
		//printNotNullActorAddressGAs();
	}
	*/
	
	public void userLogin(String userName, ActorAddress playerAddress){
		boolean result = false;
		System.out.println("Inni Userlogin");

		
			for(Player pa: players){
				if(pa.getUserName().endsWith(userName)){
					result = true;

					XStream xstream = new XStream();
					xstream.setClassLoader(new Player().getClass().getClassLoader());
					xstream.alias("player", Player.class);
					xstream.alias("group", Group.class);
					xstream.setMode(XStream.XPATH_ABSOLUTE_REFERENCES);
					
					String xmlString = xstream.toXML(pa);
					
					System.out.println(xmlString);
					
					System.out.println("Klar til  sende loginsuccessful til: "+playerAddress);
					System.out.println("Sendes fra: "+asm.getMyActorAddress());
					System.out.println("Denne inneholder stringen: "+xmlString);
					
					// asm.sendMessage(new Login(xmlString), playerAddress);
					
					//this.asm.sendMessage(new LoginSuccessful(xmlString), playerAddress);
					
					// TODO for the group agent ...user your decision				
					
					break;
				}
			}
				
		if(!result){
			//asm.sendMessage(new LoginFailed(),playerAddress);
			System.out.println("Login failed...");
		}
	}
	public void addGroupNodeToXMLFile(Group g){
		try {
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			Document doc = docBuilder.parse (new File(configFileName));
			doc.getDocumentElement().normalize();
			
			NodeList groups = doc.getElementsByTagName("groups");
			
			Node newGroup = doc.createElement("group");
			groups.item(0).appendChild(newGroup);
			Node groupId = doc.createElement("groupid");
			groupId.setTextContent(g.getGroupName());
			newGroup.appendChild(groupId);
			Node groupLeader = doc.createElement("leader");
			groupLeader.setTextContent(g.getLeader());
			newGroup.appendChild(groupLeader);
			Node groupRoles = doc.createElement("grouproles");
			newGroup.appendChild(groupRoles);
			if(g.isIm()){
				Node imRole = doc.createElement("grouprole");
				imRole.setTextContent("GroupIm");
				newGroup.appendChild(imRole);
			}
			if(g.isChat()){
				Node chatRole = doc.createElement("grouprole");
				chatRole.setTextContent("GroupChat");
				newGroup.appendChild(chatRole);
			}
			if(g.isDiscussion()){
				Node discussionRole = doc.createElement("grouprole");
				discussionRole.setTextContent("GroupDiscussion");
				newGroup.appendChild(discussionRole);
			}
			Node groupPlayers = doc.createElement("groupplayers");
			newGroup.appendChild(groupPlayers);
			if(g.getPlayers().size() == 0){
				Node groupPlayer = doc.createElement("groupplayer");
				newGroup.appendChild(groupPlayer);
			}else{
				for (int i = 0; i < g.getPlayers().size(); i++) {
					Node groupPlayer = doc.createElement("groupplayer");
					groupPlayer.setTextContent(g.getPlayers().elementAt(i).getUserName());
					newGroup.appendChild(groupPlayer);
				}
			}
			Transformer tFormer = TransformerFactory.newInstance().newTransformer();

	        tFormer.setOutputProperty(OutputKeys.METHOD, "xml");
	        tFormer.setOutputProperty(OutputKeys.INDENT,"yes" );
		    tFormer.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2");

	        Source source = new DOMSource(doc);
	        Result result = new StreamResult(new File(configFileName));
	        tFormer.transform(source, result);
	        System.out.println("File creation successfully!");
			
		}catch (SAXParseException err) {
			System.out.println ("** Parsing error" + ", line " + err.getLineNumber () + ", uri " + err.getSystemId ());
			System.out.println(" " + err.getMessage ());

		}catch (SAXException e) {
			Exception x = e.getException ();
			((x == null) ? e : x).printStackTrace ();

		}catch (Throwable t) {
			t.printStackTrace ();
		}
		
	}
	public void deleteGroupInXMLFile(Group g){
		try{
			Node groupToDelete = null;
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			Document doc = docBuilder.parse (new File(configFileName));
			doc.getDocumentElement().normalize();
			NodeList groups = doc.getElementsByTagName("group");
			System.out.println(groups.getLength());
			for (int i = 0; i < groups.getLength(); i++) {
				System.out.println(i+" runde");
				Node firstGroupNode = groups.item(i); 
				if(firstGroupNode.getNodeType() == Node.ELEMENT_NODE){
					Element firstGroupElement = (Element)firstGroupNode;
					
					NodeList groupIdList = firstGroupElement.getElementsByTagName("groupid");
					Element groupIdElement = (Element)groupIdList.item(0);
					
					NodeList textList = groupIdElement.getChildNodes();
					String usernameText = ((Node)textList.item(0)).getNodeValue().trim();
					
					if(usernameText.equals(g.getGroupName())){
						System.out.println("Her er den inne i if");
						groupToDelete = firstGroupNode;
						break;
					}
					
				}	
			}
			if(groupToDelete != null){
				
				Node parent = groupToDelete.getParentNode();
				parent.removeChild(groupToDelete);
				
				Transformer tFormer = TransformerFactory.newInstance().newTransformer();

		        tFormer.setOutputProperty(OutputKeys.METHOD, "xml");
		        tFormer.setOutputProperty(OutputKeys.INDENT,"yes" );
			    tFormer.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2");

		        Source source = new DOMSource(doc);
		        Result result = new StreamResult(new File(configFileName));
		        tFormer.transform(source, result);
		   	}
			
		}catch (SAXParseException err) {
			System.out.println ("** Parsing error" + ", line " + err.getLineNumber () + ", uri " + err.getSystemId ());
			System.out.println(" " + err.getMessage ());

		}catch (SAXException e) {
			Exception x = e.getException ();
			((x == null) ? e : x).printStackTrace ();

		}catch (Throwable t) {
			t.printStackTrace ();
		}
	}
	public void addPlayerNodeToXMLFile(Player p){
		try {
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			Document doc = docBuilder.parse (new File(configFileName));
			doc.getDocumentElement().normalize();
			NodeList players = doc.getElementsByTagName("players");
			
			Node newPlayer = doc.createElement("player");
			newPlayer.setTextContent("");
			players.item(0).appendChild(newPlayer);
			Node playerUserName = doc.createElement("username");
			playerUserName.setTextContent(p.getUserName());
			newPlayer.appendChild(playerUserName);
			Node playerPassword = doc.createElement("password");
			playerPassword.setTextContent("testepassord");
			newPlayer.appendChild(playerPassword);
			if(p.isIm()){
				Node imRole = doc.createElement("playerrole");
				imRole.setTextContent("PlayerIm");
				newPlayer.appendChild(imRole);
			}
			if(p.isChat()){
				Node chatRole = doc.createElement("playerrole");
				chatRole.setTextContent("PlayerChat");
				newPlayer.appendChild(chatRole);
			}
			if(p.isDiscussion()){
				Node discussionRole = doc.createElement("playerrole");
				discussionRole.setTextContent("DiscussionForum");
				newPlayer.appendChild(discussionRole);
			}
						
			Transformer tFormer = TransformerFactory.newInstance().newTransformer();

	        tFormer.setOutputProperty(OutputKeys.METHOD, "xml");
	        tFormer.setOutputProperty(OutputKeys.INDENT,"yes" );
		    tFormer.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2");

	        Source source = new DOMSource(doc);
	        Result result = new StreamResult(new File(configFileName));
	        tFormer.transform(source, result);
	        System.out.println("File creation successfully!");
						
		}catch (SAXParseException err) {
			System.out.println ("** Parsing error" + ", line " + err.getLineNumber () + ", uri " + err.getSystemId ());
			System.out.println(" " + err.getMessage ());

		}catch (SAXException e) {
			Exception x = e.getException ();
			((x == null) ? e : x).printStackTrace ();

		}catch (Throwable t) {
			t.printStackTrace ();
		}
	}
	
	
	public void deletePlayerInXMLFile(Player p){
		try{
			Node playerToDelete = null;
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			Document doc = docBuilder.parse (new File(configFileName));
			doc.getDocumentElement().normalize();
			NodeList players = doc.getElementsByTagName("player");
			System.out.println(players.getLength());
			for (int i = 0; i < players.getLength(); i++) {
				System.out.println(i+" runde");
				Node firstPlayerNode = players.item(i); 
				if(firstPlayerNode.getNodeType() == Node.ELEMENT_NODE){
					Element firstPlayerElement = (Element)firstPlayerNode;
					
					NodeList playerIdList = firstPlayerElement.getElementsByTagName("username");
					Element playerIdElement = (Element)playerIdList.item(0);
					
					NodeList textList = playerIdElement.getChildNodes();
					String usernameText = ((Node)textList.item(0)).getNodeValue().trim();
					System.out.println("!!!!!!!!!!!!!!!");
					System.out.println(usernameText);
					System.out.println(p.getUserName());
					if(usernameText.equals(p.getUserName())){
						System.out.println("Her er den inne i if");
						playerToDelete = firstPlayerNode;
						break;
					}
					
				}	
			}
			if(playerToDelete != null){
				
				Node parent = playerToDelete.getParentNode();
				parent.removeChild(playerToDelete);
				
				Transformer tFormer = TransformerFactory.newInstance().newTransformer();

		        tFormer.setOutputProperty(OutputKeys.METHOD, "xml");
		        tFormer.setOutputProperty(OutputKeys.INDENT,"yes" );
			    tFormer.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2");

		        Source source = new DOMSource(doc);
		        Result result = new StreamResult(new File(configFileName));
		        tFormer.transform(source, result);
		   	}
			
		}catch (SAXParseException err) {
			System.out.println ("** Parsing error" + ", line " + err.getLineNumber () + ", uri " + err.getSystemId ());
			System.out.println(" " + err.getMessage ());

		}catch (SAXException e) {
			Exception x = e.getException ();
			((x == null) ? e : x).printStackTrace ();

		}catch (Throwable t) {
			t.printStackTrace ();
		}
	}

	public Vector<Player> loadPlayersFromXMLFile() {
		players = new Vector<Player>();
		try {
			
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			Document doc = docBuilder.parse (new File(configFileName));

			// normalize text representation
			doc.getDocumentElement ().normalize ();	
			
			//------ Loading the players
					
			NodeList listOfPlayers = doc.getElementsByTagName("player");
			//int totalPlayers = listOfPlayers.getLength();
			//System.out.println("Total no of Players : " + totalPlayers);

			
					
			for(int p=0; p<listOfPlayers.getLength(); p++){
						
				Player player = new Player();
				System.out.println(player.toString());
				Node firstPlayerNode = listOfPlayers.item(p);
						
				if(firstPlayerNode.getNodeType() == Node.ELEMENT_NODE){
				//get player id
					Element firstPlayerElement = (Element)firstPlayerNode;
						
					NodeList playerUserNameList = firstPlayerElement.getElementsByTagName("username");
					Element playerUserNameElement = (Element)playerUserNameList.item(0);
					
					NodeList userNameTextList = playerUserNameElement.getChildNodes();
					String usernameText = ((Node)userNameTextList.item(0)).getNodeValue().trim();
						
					player.setUserName(usernameText);
					//get player password
					NodeList playerPasswordList = firstPlayerElement.getElementsByTagName("password");
					Element playerPasswordElement = (Element)playerPasswordList.item(0);

					NodeList passwordList = playerPasswordElement.getChildNodes();
					String playerPassword = ((Node)passwordList.item(0)).getNodeValue().trim();
					//System.out.println("Loading password : " + playerPassword);
						
					player.setPassword(playerPassword);
					//get player roles
					NodeList playerListOfRoles = doc.getElementsByTagName("playerrole");
											
						
					for (int t = 0; t < playerListOfRoles.getLength(); t++) {
						
						Node firstRoleNode = playerListOfRoles.item(t);
						if(firstRoleNode.getNodeType()== Node.ELEMENT_NODE){
							
							Element playerRoleElement = (Element)firstRoleNode;
							NodeList roleList = playerRoleElement.getChildNodes();
							String rolle =  ((Node)roleList.item(0)).getNodeValue().trim();		
							if(rolle.equals("PlayerChat")){
								player.setChat(true);
							}else if(rolle.equals("DiscussionForum")){
								player.setDiscussion(true);
							}else if(rolle.equals("PlayerIm")){
								player.setIm(true);
							}else if(rolle.equals("LocationAwareness")){
								player.setLocationAwareness(true);
							}else if(rolle.equals("CommunityAwareness")){
								player.setCommunityAwareness(true);
							}
						}
					}
					players.add(player);
					
					playerHash.put(player.getUserName(), player);
					
				}
				//end of if
					
			}	
			//end of player iteration
					
			
			
		}catch (SAXParseException err) {
			System.out.println ("** Parsing error" + ", line " + err.getLineNumber () + ", uri " + err.getSystemId ());
			System.out.println(" " + err.getMessage ());

		}catch (SAXException e) {
			Exception x = e.getException ();
			((x == null) ? e : x).printStackTrace ();

		}catch (Throwable t) {
			t.printStackTrace ();
		}
		//System.exit (0);

		return players;
	}
	public Vector<Group> loadGroupsFromXMLFile() {
		groups = new Vector<Group>();
		try {

			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			Document doc = docBuilder.parse (new File(configFileName));

			// normalize text representation
			doc.getDocumentElement ().normalize ();
			//System.out.println ("Root element of the doc is " + doc.getDocumentElement().getNodeName());


			NodeList listOfGroups = doc.getElementsByTagName("group");
			//int totalGroups = listOfGroups.getLength();
			//System.out.println("Total no of groups : " + totalGroups);

			for(int s=0; s<listOfGroups.getLength() ; s++){

				Node firstGroupNode = listOfGroups.item(s);
				if(firstGroupNode.getNodeType() == Node.ELEMENT_NODE){
					
					Group group = new Group();
					
					Element firstGroupElement = (Element)firstGroupNode;

					//-------
					NodeList groupNameList = firstGroupElement.getElementsByTagName("groupid");
					Element groupNameElement = (Element)groupNameList.item(0);

					NodeList groupTNList = groupNameElement.getChildNodes();
					String groupId = ((Node)groupTNList.item(0)).getNodeValue().trim();
					//System.out.println("Loading Group Name : " + groupName);
					
					group.setGroupName(groupId);
					//group.setId(s);
					
					NodeList groupLeaderList = firstGroupElement.getElementsByTagName("leader");
					Element groupLeaderElement = (Element)groupLeaderList.item(0);
					
					NodeList leaderList = groupLeaderElement.getChildNodes();
					String leader = ((Node)leaderList.item(0)).getNodeValue().trim();
					
					group.setLeader(leader);
					
					//load in all roles for a group
					NodeList listOfRoles = firstGroupElement.getElementsByTagName("grouprole"); 
					for(int r=0; r<listOfRoles.getLength(); r++){
						Node firstRoleNode = listOfRoles.item(r);
						if(firstRoleNode.getNodeType()== Node.ELEMENT_NODE){
							Element groupRoleElement = (Element)firstRoleNode;
							NodeList roleList = groupRoleElement.getChildNodes();
							String rolle =  ((Node)roleList.item(0)).getNodeValue().trim();		
							if(rolle.equals("GroupChat")){
								group.setChat(true);
							}else if(rolle.equals("GroupDiscussion")){
								group.setDiscussion(true);
							}else if(rolle.equals("GroupIm")){
								group.setIm(true);
							}
						}
					}
					NodeList listOfPlayers = firstGroupElement.getElementsByTagName("groupplayer");
					for (int i = 0; i < listOfPlayers.getLength(); i++) {
						Node firstPlayerNode = listOfPlayers.item(i);
						if(firstPlayerNode.getNodeType() == Node.ELEMENT_NODE){
							Element playerElement = (Element)firstPlayerNode;
							NodeList playerList = playerElement.getChildNodes();
							String playerId = ((Node)playerList.item(0)).getNodeValue().trim();
							for(Player pa:players){
								if(pa.getUserName().equals(playerId)){
									group.addPlayer(pa);
									pa.addGroup(group);
									
								}
							}
						}
					}
					groups.add(group);
				}
			}
		}catch (SAXParseException err) {
			System.out.println ("** Parsing error" + ", line " + err.getLineNumber () + ", uri " + err.getSystemId ());
			System.out.println(" " + err.getMessage ());

		}catch (SAXException e) {
			Exception x = e.getException ();
			((x == null) ? e : x).printStackTrace ();

		}catch (Throwable t) {
			t.printStackTrace ();
		}
		//System.exit (0);

		return groups;
	}	
	
	
	public Vector<Group> getGroups() {
		return groups;
	}

	public void setGroups(Vector<Group> groups) {
		this.groups = groups;
	}
	public Vector<Player> getPlayers(){
		return players;
	}
	public void setPlayers(Vector<Player> players){
		this.players = players;
	}

	public ActorSM getAsm() {
		return asm;
	}

	public void setAsm(ActorSM asm) {
		this.asm = asm;
	}
}
