package no.item.ntnu.arctis.examples.cityguide.locationserviceproxy;


import org.apache.log4j.xml.DOMConfigurator;

import no.ntnu.item.arctis.library.objects.location.Location;
import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class LocationServiceProxy extends Block{

	static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger("LocationServiceProxy.Class");
	
	public no.ntnu.item.arctis.library.proxies.Message message;

	public void found(Address addr) {
		System.out.println("Location service is found.."+addr.toString());
		logger.warn("> "+ "in found, Location service is found.."+addr.toString());
	}

	public void notfound() {
			System.out.println("Location service is not found..");
			logger.warn("> "+ "in nofound, Location service is no found..");
	}

	public Message createPinMessage() {
		System.out.println("creating pin msg at Location Service proxy");
		logger.warn("> "+ "in createPinMessage, creating pin msg at Location Service proxy..");
		
		Message m = new Message("location");
		m.setPayload("");
		return m;
	}

	public Location extractMessage(Message msg) {
	
		System.out.println("received message from Location Server at Location proxy......"+msg);
		
		Location loc = new Location();
		
		if (msg.getPayload() instanceof String){	
			String  str = (String)  msg.getPayload();
			// not get the location 
			double latitude = Double.valueOf(str.split("_")[0]);
			double longitude = Double.valueOf(str.split("_")[1]);
			
			System.out.println("after parsing in extractMessage of Location Service Proxy.. "+ "lat lon "+ latitude + " "+ longitude);
			logger.warn("> "+ "in extractMessage, Location is received. lat= " + latitude + ", lan = "+longitude);
			
			loc.setLatitude(latitude);
			loc.setLongitude(longitude);
			return loc;
		}
		else {
			// to do
			return (Location) msg.getPayload();
		}
	}

	public void startDiscover() {
			DOMConfigurator.configure("log4j.xml");
			logger.warn("> "+ "in startDiscover, starting to discover Location Service");
	}


}