package no.item.ntnu.arctis.examples.cityguide.webserver;


import java.io.IOException;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;
import java.util.Map.Entry;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import no.ntnu.item.arctis.library.objects.quiz.Game;
import no.ntnu.item.arctis.library.objects.quiz.Treasures;
import no.ntnu.item.arctis.library.objects.user.Player;
import no.ntnu.item.arctis.library.objects.user.Group;
import no.tellu.common.actorframe.ActorSM;
import no.tellu.common.javaframe.ActorAddress;

import org.mortbay.jetty.HttpConnection;
import org.mortbay.jetty.Request;
import org.mortbay.jetty.handler.AbstractHandler;

public class MainpageHandler extends AbstractHandler {
	
	private static String recentLog = "Log";
	
	private static ActorSM asm;
	
	public MainpageHandler(ActorSM asm){
		this.asm = asm;
	}
	
	public void updateLog(String str){
		this.recentLog = str+ "\n" +recentLog;
	}
	
    public void handle(String target, HttpServletRequest request, HttpServletResponse response, int dispatch) throws IOException, ServletException
    {    	
        //System.err.println(request.getParameterMap());
    	
    	//System.out.println("you are here+ " +  target);

       	if(target.equalsIgnoreCase("/mainpage/")){           	

            Request base_request = (request instanceof Request) ? (Request)request:HttpConnection.getCurrentConnection().getRequest();
    		base_request.setHandled(true);            
                
    		Enumeration paramNames = request.getParameterNames();
    		
    		String parName;

    		boolean emptyEnum = false;
    		if (!paramNames.hasMoreElements())
    			emptyEnum = true;

    		response.setContentType("text/html");
    		java.io.PrintWriter out = response.getWriter();

    		out.println("<html><head>");
    		out.println("<title>Submitted Parameters</title></head><body>");

    		if (emptyEnum) {
    			out.println("<h2>No parameters</h2>");
    		} else {
    			// out.println("<h2>Here are the submitted parameter values</h2>");
    		}

    		boolean login = false;
    		boolean createNewGame = false;
    		
    		while (paramNames.hasMoreElements()) {

    			parName = (String) paramNames.nextElement();
    			
    			if(parName.endsWith("password") & request.getParameter(parName).endsWith("admin")){
    				login = true;
    				break;
    			}			
    			else if(parName.equalsIgnoreCase("create_game_button")){
    				if(request.getParameter(parName).equalsIgnoreCase("Create Game")){
    					createNewGame = true;
    					break;
    				}
    			}
    		}
    		
    		/*
    		 *  if new game is create save it and 
    		 *  update the game hash map at teacher and 
    		 *  send update message to server
    		 */
    		if(createNewGame){
    			/*
    	    	Game newGame = new Game();    		
    			
    	    	Utilities util = new Utilities();
    	    	
    	    	newGame.setName(request.getParameter("gameNameText"));
    	    	 	    	
    	    	newGame.setGroups(util.getGroups(this.asm, request.getParameterValues("gselect")));
   			
    	    	newGame.setTreasures(util.getTreasures(this.asm, request.getParameterValues("tselect")));
    	    	
    	    	((TeacherAgentSM)asm).games.put(newGame.getName(), newGame);
    	    	
    	    	util.writeGameToXMLFile(newGame);
    	    	*/
    		}
    		
    		if(login | createNewGame) {  

    			System.out.println("you are here+- " +  target);
    			
    			String newline = "<br/>";
    			
        		response.setContentType("text/html");
        		response.setStatus(HttpServletResponse.SC_OK);
        		
        		response.getWriter().println(newline);

        		response.getWriter().println("<h1>" + "Welcome To City Server"+ "</h1>");     
        		
        		response.getWriter().println("<hr>");   
        		
        		response.getWriter().println(recentLog);

        		
        		// read and print file
        		try{
        			// Open the file that is the first 
        			// command line parameter
        			java.io.FileInputStream fstream = new java.io.FileInputStream("example.log");
        			// Get the object of DataInputStream
        			java.io.DataInputStream in = new java.io.DataInputStream(fstream);
        			java.io.BufferedReader br = new java.io.BufferedReader(new java.io.InputStreamReader(in));
        			String strLine;
        			//Read File Line By Line
        			while ((strLine = br.readLine()) != null)   {
        				// Print the content on the console
        				response.getWriter().println(strLine);
        				response.getWriter().println("<br/>");
        				response.getWriter().println("<br/>");
        			}
        			//Close the input stream
        			in.close();
        		}catch (Exception e){//Catch exception if any
        			response.getWriter().println("Error: " + e.getMessage());
        		}

        		/*
        		// form to display existing users
        		response.getWriter().println("<FORM NAME=userform ACTION=http://localhost:8080/param/ METHOD=POST>");
        		       		
        		response.getWriter().println("<table cellspacing=\"0\" cellpadding=\"5\" border=\"1\">");    		      		
        		
        		response.getWriter().println("<tr>");
        		response.getWriter().println("<td>"+ "Player Name"+ "</td> ");
        		response.getWriter().println("<td>"+"Member of" + "</td> ");
        		response.getWriter().println("</tr>");        		
        		
        		for (int i = 0; i < ((TeacherAgentSM)asm).playerConfig.size(); i++) {			
        			response.getWriter().println("<tr>");    			
        			Player player = (Player) ((TeacherAgentSM)asm).playerConfig.elementAt(i);
            		response.getWriter().println("<td>"+ "<a href=\"/\">"+ player.getUserName() +"</a>" + "</td> ");
            		
            		String groups="";
            		for (int j = 0; j < player.getGroups().size(); j++) {
            			if(j==0) groups = ((Group)player.getGroups().elementAt(j)).getGroupName();
            			else groups = groups + ", "+ ((Group)player.getGroups().elementAt(j)).getGroupName();
					}      		
            		response.getWriter().println("<td>"+ groups + "</td> ");
            		response.getWriter().println("</tr>");
        		}        		
        		response.getWriter().println( "</table>");
        	        		
        		response.getWriter().println("<INPUT TYPE=submit VALUE=\"New User\" NAME=treasurebutton>");        		
        		response.getWriter().println("</FORM>");
        		
        		
        		
         		// form to display existing groups
        		response.getWriter().println("<FORM NAME=groupform ACTION=http://localhost:8080/param/ METHOD=POST>");
        		
        		response.getWriter().println("<table cellspacing=\"0\" cellpadding=\"5\" border=\"1\">");    		      		
        		
        		response.getWriter().println("<tr>");
        		response.getWriter().println("<td>"+ "Group Name"+ "</td> ");
        		response.getWriter().println("<td>"+"Players" + "</td> ");
        		response.getWriter().println("<td>"+ "Group Addr"+ "</td> ");
        		response.getWriter().println("</tr>");        		
        		
        		for (int i = 0; i < ((TeacherAgentSM)asm).groupConfig.size(); i++) {			
        			response.getWriter().println("<tr>");    			
        			Group group = (Group) ((TeacherAgentSM)asm).groupConfig.elementAt(i);
            		response.getWriter().println("<td>"+ "<a href=\"/\">"+ group.getGroupName()+"</a>" + "</td> ");
            		
            		String players="";
            		for (int j = 0; j < group.getPlayers().size(); j++) {
            			if(j==0) players = ((Player)group.getPlayers().elementAt(j)).getUserName();
            			else players = players + ", "+ ((Player)group.getPlayers().elementAt(j)).getUserName();
					}      		
            		response.getWriter().println("<td>"+ players + "</td> ");
            		
            		response.getWriter().println("<td>"+ group.getActorAddress() + "</td> ");
            		response.getWriter().println("</tr>");
        		}        		
        		response.getWriter().println( "</table>");
        	        		
        		response.getWriter().println("<INPUT TYPE=submit VALUE=\"New Group\" NAME=treasurebutton>");        		
        		response.getWriter().println("</FORM>");
        		
        		
        		// form to display existing games
        		response.getWriter().println("<FORM NAME=\"gameform\" ACTION=\"http://localhost:8080/game/\" METHOD=POST>");
        		
        		response.getWriter().println("<table cellspacing=\"0\" cellpadding=\"5\" border=\"1\">");    		
        		
        		response.getWriter().println("<tr>");
        		response.getWriter().println("<td>"+ "Game Name"+ "</td> ");
        		response.getWriter().println("<td>"+"Treasures" + "</td> ");
        		response.getWriter().println("<td>"+"Groups" + "</td> ");
        		response.getWriter().println("<td>"+ "" + "</td> ");
        		response.getWriter().println("</tr>");        		
        		
        		Iterator itx = ((TeacherAgentSM)asm).games.entrySet().iterator();
        		while(itx.hasNext()){
            		response.getWriter().println("<tr>");
            		
        			Map.Entry<String, Game> mex = (Entry<String, Game>) itx.next();
        			
            		response.getWriter().println("<td>"+ "<a href=\"/\">"+ mex.getKey()+"</a>" + "</td> ");

            		Game game = mex.getValue();
            		
            		String ts = "";
        			for (int i = 0; i < game.getTreasures().size(); i++) {						
        				Treasures tx =  game.getTreasures().elementAt(i);        				
        				if(i==0) ts = tx.getName();
        				else ts =  ts + ", " + "<BR>"+ tx.getName();    				
					}       			
            		response.getWriter().println("<td>"+ ts + "</td> ");
            		
            		String gs = "";
            		for (int i = 0; i < game.getGroups().size(); i++) {
            			Group gx =  game.getGroups().elementAt(i);        				
        				if(i==0) gs = gx.getGroupName();
        				else gs = gs + ", " + "<BR>" +gx.getGroupName();
					}
            		response.getWriter().println("<td>"+ gs + "</td> ");
            		
            		response.getWriter().println("<td>"+ 
            				"["+ "<a href=\"/game/?gameid="+ mex.getKey() + "&mode=edit"+ "\">"+ "edit"+"</a>" + "]" +
            				"["+ "<a href=\"/game/?gameid="+ mex.getKey() + "&mode=start"+ "\">"+ "start"+"</a>" + "]" +
            				"</td> ");                   		
            		response.getWriter().println("</tr>");
        		}       		        		
        		response.getWriter().println( "</table>");        		
        		response.getWriter().println("<INPUT TYPE=submit VALUE=\"New Game\" NAME=new_game_button>");        		
        		response.getWriter().println("</FORM>");
        		
        		
        		// form to display existing treasures
        		response.getWriter().println("<FORM NAME=treasureform ACTION=http://localhost:8080/param/ METHOD=POST>");
        		
        		response.getWriter().println("<table cellspacing=\"0\" cellpadding=\"5\" border=\"1\">");    		      		
        		
        		response.getWriter().println("<tr>");
        		response.getWriter().println("<td>"+ "Treasure Name"+ "</td> ");
        		response.getWriter().println("<td>"+"Locations" + "</td> ");
        		response.getWriter().println("</tr>");        		
        		
        		for (int i = 0; i < ((TeacherAgentSM)asm).gameConfig.size(); i++) {			
        			response.getWriter().println("<tr>");    			
        			Treasures treasure = (Treasures) ((TeacherAgentSM)asm).gameConfig.elementAt(i);
            		response.getWriter().println("<td>"+ "<a href=\"/\">"+ treasure.getName()+"</a>" + "</td> ");
            		response.getWriter().println("<td>"+treasure.getYCoordinate()+ ", "+ treasure.getYCoordinate() + "</td> ");
            		response.getWriter().println("</tr>");
        		}        		
        		response.getWriter().println( "</table>");
        	        		
        		response.getWriter().println("<INPUT TYPE=submit VALUE=\"New Treasure\" NAME=treasurebutton>");        		
        		response.getWriter().println("</FORM>");    */    		
        		
    		}
    		
    		/*
    		else {
    			out.println("Login Fail");
    		}
    		*/
    		
    		out.println("</body></html>");
    	} 
    }
}
