package no.item.ntnu.arctis.examples.cityguide.webserver;


import no.tellu.common.actorframe.ActorSM;

import org.mortbay.jetty.Connector;
import org.mortbay.jetty.Handler;
import org.mortbay.jetty.Server;
import org.mortbay.jetty.handler.HandlerCollection;
import org.mortbay.jetty.nio.SelectChannelConnector;
import org.mortbay.jetty.servlet.Context;
import org.mortbay.jetty.servlet.ServletHolder;

public class MyWebServer {
	
	private static ActorSM asm;
	Handler login, mainpage;
	
	
	public static void main(String[] args) throws Exception
	{	  

		/*Server server = new Server(8080);
		Context root = new Context(server,"/",Context.SESSIONS);
		root.addServlet(new ServletHolder(new MyServlet("Hello !")), "/admin");
		server.start();
		server.join();*/
		
		new MyWebServer(null);
	}

	public MyWebServer(ActorSM asm){

		this.asm = asm;
		
		Server server = new Server(8080);		  

		/*
		 * Using Multiple Servlets 
		 */
		/*
	        ContextHandlerCollection contexts = new ContextHandlerCollection();
	        server1.setHandler(contexts);

	        Context root = new Context(contexts,"/admin",Context.SESSIONS);
	        root.addServlet(new ServletHolder(new MyServlet("Welcome to CityServer")), "/*");

	        Context other = new Context(contexts,"/users",Context.SESSIONS);
	        other.addServlet(new ServletHolder(new UserManagerServlet("Welcome to UserManager")), "/*");
		 */

		/*
		 * Using Multiple Handlers
		 */
		Connector connector=new SelectChannelConnector();
		connector.setPort(8080);
		server.setConnectors(new Connector[]{connector});

		mainpage=new MainpageHandler(this.asm);
		login=new LoginHandler(this.asm);
		//Handler game=new GameHandler(this.asm);

		HandlerCollection handlers = new HandlerCollection();
		handlers.setHandlers(new Handler[]{login,mainpage});//,game});
		server.setHandler(handlers);

		try {
			server.start();
			// 	server.join();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public Handler getMainpageHandler(){
		return mainpage;
	}
	
	public void stop(){
		//TODO
	}
}
