package no.ntnu.item.arctis.library.proxies.actorrouter.android;



import java.util.Enumeration;
import java.util.Hashtable;

import no.ntnu.item.arctis.android.R;
import no.tellu.common.javaframe.ActorSpec;
import no.tellu.common.javaframe.ApplicationSpec;
import no.tellu.common.javaframe.PartSpec;
import no.tellu.common.services.actorrouter.SessionManagerSpec;
import no.tellu.j2se.application.J2SEContainer;
import android.content.Context;
import android.content.Intent;
import android.content.res.Resources;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;



public class ActorframeContainer extends BasicService implements LocationListener{

	
	private J2SEContainer container;
    private LocationManager locationManager;

	/*
	 * Should not be static to conform
	 * */
	//public static PlayerAgentSM pa_asm;
	//public static SocialMatchingRole_PlayerAgentSM smpa;
	
	public static boolean loggedIn = false;
	public static boolean exit = false;
	
	public Handler handler;
	
	Intent myIntent;
	
	private static ActorframeContainer context;
	
	//
	private ApplicationSpec applicationSpec;
	
	@Override
    public void onCreate() {
		System.out.println("in onCreate ActorframeContainer");
		this.locationManager = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);    
		this.handler = new Handler();
		context = this;
		
		// UpdateUnit.init(this);
		
		// initThread.start();
		super.onCreate();
	}
	
	 //need thread for spawning actorframe model to not lock
	// UI thread. Should notify when connecting to server fails
	private Thread initThread = new Thread(){
		@Override
		public void run(){
			try {
								
				System.out.println("ActorframeContainer initThread runs");
				
				Resources res = ActorframeContainer.this.getResources();
				UserApplication client = new UserApplication(res.openRawResource(R.raw.clientrouterapplicationspec));
				
				// added for getting the application spec
				ActorframeContainer.this.applicationSpec = client.getApplicationSpec();
				
				ActorframeContainer.this.container = new J2SEContainer(client);								
				ActorframeContainer.this.container.init();
				ActorframeContainer.this.container.start(); 
				
			} catch (Exception e) {
				e.printStackTrace();
			}
			
		}
		
	};
	
    @Override
	public void onStart(Intent intent, int startId){
    	System.out.println("in onStart ActorframeContainer");
    	String newGetGatewayIP= intent.getStringExtra("gatewayIP");
    	String newGatewayPort = intent.getStringExtra("gatewayPort");
    	String newListnerPort = intent.getStringExtra("listnerPort"); 
		
    	applicationSpecChanged(newGetGatewayIP, Integer.valueOf(newGatewayPort), Integer.valueOf(newListnerPort));
	}
	
    @Override
    public void onDestroy() {
	    initThread.stop();
	  //  UpdateUnit.closeDB();
    	super.onDestroy();
	    Log.v("SERVICE","Login service killed");
    	
    }

    //End Region Core 
    
   
  
	/*
	public void registerMainPort(MainPort port){
		UpdateUnit.setMainPort(port);
		Log.v("AFcontainer","Registered main port");
	}

	public void registerUserInfoPort(UserInfoPort port){
		UpdateUnit.setUserInfoPort(port);
		Log.v("AFcontainer","Registered user info port");
	}
	
	public void registerSocialMatchingPort(SocialMatchingPort port){
		UpdateUnit.setSocialMatchingPort(port);
		Log.v("AFcontainer","Registered social matching info port");
	}
	*/

	////////////////////////////////////////////////////
	//LocationListener interface
	@Override
	public void onLocationChanged(Location location) {
		Log.v("","Location " + location.getLatitude()+","+ location.getLongitude());
		
		/*
		Double lat_d = location.getLatitude();
		Double lon_d = location.getLongitude();
		
		//reference to SMPA is valid
		if(smpa != null){
			
			no.ntnu.item.ttm4115.termproject.Location signal = new no.ntnu.item.ttm4115.termproject.Location();
			signal.lat = lat_d.toString();
			signal.lng = lon_d.toString();
			
			//send location update
			smpa.sendMessage(signal, smpa.getMyActorAddress());
		}
		
		
		int lat_i = (int) (lat_d*1E6);
		int lon_i = (int) (lon_d*1E6);
		
		no.ntnu.item.common.datatypes.Location loc =new no.ntnu.item.common.datatypes.Location(lat_i,lon_i);
		
		UpdateUnit.updateMyLocation(loc);
		*/
		
	}

	@Override
	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		//switch location provider here
		
	}
	

	
	
    //sets location manager and starts position updates
	public void setLocationManager(String provider){
		this.locationManager.removeUpdates(this);
		this.locationManager.requestLocationUpdates(provider, 
		5000,  // 5 seconds
		50, // 50 meters
		this); 
		Log.v("","locationmanager changed to " + provider);
	}
	
	public void stopPositioning(){
    	this.locationManager.removeUpdates(this);
    }
    
	
	////////////////////////////////////////////////////

	/*
	public static void registerPlayerAgent(PlayerAgentSM asm){
		pa_asm = asm;
	}
	
	public static void registerSMPA(SocialMatchingRole_PlayerAgentSM asm){
		smpa = asm;
	}
	*/
	
	public void killActorFrameModel(){
		this.container.exit();
	}

	public static ActorframeContainer getContext(){
		return context;
	}
	
	
	// method to update the change in application specification
	public void applicationSpecChanged(String newGetGatewayIP){

		System.out.println("inside ActorframeContainer applicationSpecChanged");

		// 129.241.221.252

		// update resource file
		if(this.initThread.isAlive()){
			this.initThread.interrupt(); 
			//this.initThread.join();
		}

		// update the configuration file and application spec
		ApplicationSpec spec = ActorframeContainer.this.applicationSpec;
				
		Enumeration en = spec.getSessionManagers();

		Hashtable managers = new Hashtable();
		while(en.hasMoreElements()){	 	
			String key = (String) en.nextElement();			    	
			System.out.println("key..."+ key);	
						
			SessionManagerSpec sp = spec.getSessionManagerSpec(key);			    	
			String type= sp.getType();
			String id = sp.getId();
			String className = sp.getClassName();
			int gatewayPort = sp.getGatewayPort();
			int listnerPort = sp.getListnerPort();
			String gatewayIP = sp.getGatewayIP();
			
			System.out.println("getType Value..."+ sp.getType());
			System.out.println("getId Value..."+ sp.getId());
			System.out.println("getClassName Value..."+ sp.getClassName());
			System.out.println("getGatewayPort Value..."+ sp.getGatewayPort());
			System.out.println("getListnerPort Value..."+ sp.getListnerPort());
			System.out.println("getGatewayIP Value..."+ sp.getGatewayIP());	
			
			//gatewayIP = "129.241.221.252";
			
            SessionManagerSpec smSpec = new SessionManagerSpec(type, id, className, newGetGatewayIP, gatewayPort, listnerPort);
            managers.put(id, smSpec);   
            
    		System.out.println("getType Value..."+ smSpec.getType());
			System.out.println("getId Value..."+ smSpec.getId());
			System.out.println("getClassName Value..."+ smSpec.getClassName());
			System.out.println("getGatewayPort Value..."+ smSpec.getGatewayPort());
			System.out.println("getListnerPort Value..."+ smSpec.getListnerPort());
			System.out.println("getGatewayIP Value..."+ smSpec.getGatewayIP());	         
		}
		
		spec.setSessionManagers(managers);

		ActorframeContainer.this.applicationSpec = spec;
		
		// start a new thread
		this.initThread = new Thread(){
			@Override
			public void run(){
				try {

					System.out.println("ActorframeContainer initThread runs again");

					// Resources res = ActorframeContainer.this.getResources();
					//UserApplication client = new UserApplication(res.openRawResource(R.raw.userapplicationspec));

					UserApplication client = new UserApplication(ActorframeContainer.this.applicationSpec);

					ActorframeContainer.this.container = new J2SEContainer(client);
					ActorframeContainer.this.container.init();
					ActorframeContainer.this.container.start();

				} catch (Exception e) {
					e.printStackTrace();
				}

			}							
		};
		this.initThread.start();
	}
	
	public String now() {
	    java.util.Calendar cal = java.util.Calendar.getInstance();
	    java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat("yyyyMMddhhmmssSSS");
	    return sdf.format(cal.getTime());
	}

	// method to update the change in application specification
	public void applicationSpecChanged(String newGetGatewayIP, int newGatewayPort, int newListnerPort){
		System.out.println("in applicationSpecChanged ActorframeContainer...");

		// update resource file
		if(this.initThread.isAlive()){
			this.initThread.interrupt(); 
			//this.initThread.join();
		}

		try {		
			Resources res = ActorframeContainer.this.getResources();
			UserApplication client = new UserApplication(res.openRawResource(R.raw.clientrouterapplicationspec));
			ActorframeContainer.this.applicationSpec = client.getApplicationSpec();
				
			// update the configuration file and application spec
			ApplicationSpec spec = ActorframeContainer.this.applicationSpec;
			
			// change the role instance of router
			ActorSpec actorSpec = spec.getActorSpec("ActorDomain");				
			spec.removeActorSpec("ActorDomain");
			PartSpec part = actorSpec.getPartSpec("Router");
			actorSpec.deletePartSpec("Router");
			String [] rnames = part.getRoleNames();
			String str_date= now();
			str_date = str_date.replaceAll(" ", "");
			rnames[0] = str_date + rnames[0];
			part.setRoleNames(rnames);
			actorSpec.addPartSpec(part);
			spec.addActorSpec(actorSpec);	
			
			// change the session manager spec
			Enumeration en = spec.getSessionManagers();
			Hashtable managers = new Hashtable();
			while(en.hasMoreElements()){	 	
				String key = (String) en.nextElement();			    	
				//System.out.println("key..."+ key);							
				SessionManagerSpec sp = spec.getSessionManagerSpec(key);			    	
				String type= sp.getType();
				String id = sp.getId();
				String className = sp.getClassName();
				int gatewayPort = sp.getGatewayPort();
				int listnerPort = sp.getListnerPort();
				String gatewayIP = sp.getGatewayIP();
												
	            SessionManagerSpec smSpec = new SessionManagerSpec(type, id, className, newGetGatewayIP, newGatewayPort, newListnerPort);
	            managers.put(id, smSpec);   
	            
	    		System.out.println("getType Value..."+ smSpec.getType());
				System.out.println("getId Value..."+ smSpec.getId());
				System.out.println("getClassName Value..."+ smSpec.getClassName());
				System.out.println("getGatewayPort Value..."+ smSpec.getGatewayPort());
				System.out.println("getListnerPort Value..."+ smSpec.getListnerPort());
				System.out.println("getGatewayIP Value..."+ smSpec.getGatewayIP());	         
			}		
			spec.setSessionManagers(managers);

			//update the applicationSpec again
			ActorframeContainer.this.applicationSpec = spec;			
		} catch (Exception e) {
			// TODO: handle exception
		}
				
		// initialize a new thread
		this.initThread = new Thread(){
			@Override
			public void run(){
				try {
					System.out.println("in ActorframeContainer initThread runs...");
					UserApplication client = new UserApplication(ActorframeContainer.this.applicationSpec);
					ActorframeContainer.this.container = new J2SEContainer(client);
					ActorframeContainer.this.container.init();
					ActorframeContainer.this.container.start();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}							
		};
		
		// start a new thread
		this.initThread.start();
	}
	
}
