package no.item.ntnu.arctis.examples.cityguide.cityguideservice;


import java.util.HashSet;
import java.util.Vector;

import no.ntnu.item.arctis.library.objects.location.Location;
import no.ntnu.item.arctis.library.objects.login.Credentials;
import no.ntnu.item.arctis.library.objects.quiz.Question;
import no.ntnu.item.arctis.library.objects.quiz.SessionOption;
import no.ntnu.item.arctis.library.objects.quiz.SessionQuestion;
import no.ntnu.item.arctis.library.objects.quiz.Treasures;
import no.ntnu.item.arctis.runtime.Block;

import org.apache.log4j.xml.DOMConfigurator;

import com.thoughtworks.xstream.XStream;

public class CityGuideService extends Block {

	public no.ntnu.item.arctis.library.objects.quiz.Game game;
	public no.ntnu.item.arctis.library.objects.location.Location loc;
	public no.ntnu.item.arctis.library.objects.login.Credentials userCred;
	public java.util.HashSet visitedTreasures = new HashSet();
	public boolean isFirst = true;
	public java.util.Vector<no.ntnu.item.arctis.library.objects.quiz.Treasures> treasures;
	
	static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger("CityGuideService.Class");
	
	
	private static double THRESHOLD_DISTANCE_METER=35.0;
	public boolean process = true;
	public no.ntnu.item.arctis.library.objects.location.Location tempLoc;
	public java.sql.Connection dbConn;
	
	public boolean isTreasureAt(Location loc) {
		System.out.println("checking if isTreasureAt..."+ loc.getLatitude() +" " + loc.getLongitude());
		
		logger.warn("> "+ "in isTreasureAt, Checking if isTreasureAt..."+ loc.getLatitude() +" " + loc.getLongitude());
		
				
		// multiplied by hundred just to set a matching criteria for 4 digits
		double x1 =  loc.getLatitude() * 100;
		double y1 =  loc.getLongitude() * 100;
	
		//for(int i=0; i<this.game.getTreasures().size(); i++){
		for(int i=0; i<this.treasures.size(); i++){
			//Treasures t = game.getTreasures().elementAt(i);
			Treasures t = treasures.elementAt(i);
			
			// make sure that this treasure is not visited before
			if (!this.visitedTreasures.contains(t.getName())){	
				/*
				int x11 = Integer.valueOf(Integer.toString(t.getXCoordinate()).substring(0, 4));
				int y11 = Integer.valueOf(Integer.toString(t.getYCoordinate()).substring(0, 4));
				
				if(y11 == (int)x1 & x11 == (int)y1){				
					if(t.getQuestions().size()>0)
					{
						System.out.println("there are treasures at the location");
						return true;
					}
				}*/
				
				/**/
				String d1= String.valueOf(t.getXCoordinate());
				String d2 = d1.substring(0,d1.length()-6)+"."+d1.substring(d1.length()-6, d1.length());
				double tLong = Double.valueOf(d2);
				
				d1= String.valueOf(t.getYCoordinate());
				d2 = d1.substring(0,d1.length()-6)+"."+d1.substring(d1.length()-6, d1.length());
				double tLat = Double.valueOf(d2);
				
				System.out.println("Checking for: " +t.getName());
				logger.warn("> "+ "in isTreasureAt, Checking vicinity for: " +t.getName() + ". Distance from current location is: " + 
					new GeoLocationUtil().getDistanceBetweenTwoLocationsInMeter(loc, new Location(tLat, tLong)));			
				
				
				if(new GeoLocationUtil().areTwoPointsCloseEnough(loc, new Location(tLat, tLong), THRESHOLD_DISTANCE_METER)){
					if(t.getQuestions().size()>0)
					{
						System.out.println("There are treasures at.."+ loc.getLatitude() +" " + loc.getLongitude());
						logger.warn("> " + "in isTreasureAt, There are treasures at.."+ loc.getLatitude() +" " + loc.getLongitude());				
						return true;
					}
				}				
				/**/
			}
				
		}
		System.out.println("No Treasures at.."+ loc.getLatitude() +" " + loc.getLongitude());
		logger.warn("> " + "in isTreasureAt, No Treasures found at.."+ loc.getLatitude() +" " + loc.getLongitude());
		
		return false;
	}


	public Question getQuestions(Location loc) {
	
		System.out.println("Looking for Active Questions of a Treasure at.."+ loc.getLatitude() +" " + loc.getLongitude());
		logger.warn("> "+"in getQuestions, Looking for Active Questions of a Treasure at.."+ loc.getLatitude() +" " + loc.getLongitude());

		double x1 = loc.getLatitude() * 100;
		double y1 = loc.getLongitude() * 100;
		
		
		XStream xstream = new XStream();
		xstream.alias("sessionquestion", SessionQuestion.class);
		xstream.alias("sessionoption", SessionOption.class);
	
		//for(int i=0; i<this.game.getTreasures().size(); i++){	
		for(int i=0; i<this.treasures.size(); i++){
			//Treasures t = game.getTreasures().elementAt(i);
			Treasures t = treasures.elementAt(i);
			
			// make sure that this treasure is not visited before
			if(!this.visitedTreasures.contains(t.getName())){			
				/**/
				String d1= String.valueOf(t.getXCoordinate());
				String d2 = d1.substring(0,d1.length()-6)+"."+d1.substring(d1.length()-6, d1.length());
				double tLong = Double.valueOf(d2);
				
				d1= String.valueOf(t.getYCoordinate());
				d2 = d1.substring(0,d1.length()-6)+"."+d1.substring(d1.length()-6, d1.length());
				double tLat = Double.valueOf(d2);
				
				if(new GeoLocationUtil().areTwoPointsCloseEnough(loc, new Location(tLat, tLong), THRESHOLD_DISTANCE_METER)){
					if(t.getQuestions().size()>0)
					{
						
						String str = "";
						
						Vector<SessionQuestion> questions_ = t.getQuestions();
						str = xstream.toXML(questions_); 
						
						//System.out.println("Found Questions.."+ str);
						System.out.println("Active Questions Found..");
						logger.warn("> "+"in getQuestions, Active Questions Found.."+  str);	
						
						Question ques = new Question();
						ques.setQuestioText(str);
						
						// add this Treasure to the Visited List
						this.visitedTreasures.add(t.getName());
						
						return ques;
					}
				}				
				/**/
			}	
		}
		
		System.out.println("NO active questions list at the location");
		logger.warn("> "+"in getQuestions, NO active questions list at the location");
		return null;
	
	}

	public void fwdLocUpdate(Location loc) {
		System.out.println("fwdLocUpdate in "+ sessionID +" "+loc.getLatitude() + " " + loc.getLongitude());
		logger.warn("> "+ "in fwdLocUpdate, "+ sessionID +" "+loc.getLatitude() + " " + loc.getLongitude());
	}

	public String LocationToStr(Location loc) {
		System.out.println("in LocationToStr "+ userCred.getUserName()+ " "+loc.getLatitude()+ " " +loc.getLongitude());
		logger.warn("> "+ "in LocationToStr, "+ userCred.getUserName()+ " "+loc.getLatitude()+ " " +loc.getLongitude());
				
		return userCred.getUserName()+"#"+loc.getLatitude()+"#"+loc.getLongitude();
	}

	public void setCred(String u) {
		
		DOMConfigurator.configure("log4j.xml");

		System.out.println("User is logging in and reseting datasets");
	
		userCred = new Credentials();
		userCred.setUserName(u);
		
		// reset all
			loc = new Location();
			visitedTreasures = new HashSet<String>();
			isFirst = true;
			treasures = new Vector<no.ntnu.item.arctis.library.objects.quiz.Treasures>();
			process = true;
			tempLoc = new  Location();
		//
		
		logger.warn("> "+ "in setCred, "+ u + "logged in");
	}

	public static String getAlias(Object o) {
		return (String) o;
	}

	public void setIsFirst() {
		this.isFirst = false;
		System.out.println("in setIsFirst..");
		logger.warn("> "+"in setIsFirst, isFirst= " + isFirst);
		
	}

	public Vector<Treasures> getTreasures() {
			LoadGameConfiguration g = new LoadGameConfiguration();
			
			logger.warn("> "+ "in getTreasures, loading treasures..");
									
			return g.getTreasures();
	}

	public void retry() {
		System.out.println("Please Retry to find location service");
		logger.warn("> "+"in retry, Please Retry to find location service");
		
	}

	public void toggleProcess() {
		process = false;
		
		logger.warn("> "+ "in toggleProcess, Toggle process variable. New process = "+ process);	
	}

	public void processTrue() {
		process = true;
		
		logger.warn("> "+ " Setting process variable to true in processTrue. New process = "+ process);			
	}


	public String AddressToString( String str) {
	System.out.println("in AddressToStr "+ userCred.getUserName()+ " "+str);
		logger.warn("> "+ "in AddressToStr, "+ userCred.getUserName()+ " "+str);
				
		return userCred.getUserName()+"#"+ str;
	
	}


	public String block_AddressToString(String block_id) {
	System.out.println("in GroupChatAddressToStr "+ userCred.getUserName()+ " "+block_id);
		logger.warn("> "+ "in GroupChatAddressToStr, "+ userCred.getUserName()+ " "+block_id);
				
		return userCred.getUserName()+"#"+ block_id;
	
	}

}
