package no.ntnu.item.arctis.examples.android.cityguide.androidmapui;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import no.ntnu.item.arctis.android.R;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserFactory;

import android.app.Dialog;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.location.Location;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.Toast;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;
import com.thoughtworks.xstream.XStream;

public class ShowTheMap extends MapActivity {
	
	private static double lat;
	private static double lon;
	private int latE6;
	private int lonE6;
	private MapController mapControl;
	private GeoPoint gp;
	private MapView mapView;
	
	private Button overlayButton, accessButton;
	private Button routeButton;
	private List<Overlay> mapOverlays;
	private Drawable drawable1, drawable2, drawableLoc;
	private MyItemizedOverlay itemizedOverlay1, itemizedOverlay2, itemizedOverlayLoc;
	private boolean foodIsDisplayed = false;
	
	private Dialog exitDialog;

		
	// TODO POIS
	// Define an array containing the food overlay items
	private OverlayItem [] foodItem = {
			new OverlayItem( new GeoPoint(35952967,-83929158), "Food 1", "Food 1"), 
			new OverlayItem( new GeoPoint(35953000,-83928000), "Food  2", "Food  2"),
			new OverlayItem( new GeoPoint(35955000,-83929158), "Food  3", "Food  3") 
	};
	
	// Define an array containing the  access overlay items	
	private OverlayItem [] accessItem = {
			new OverlayItem( new GeoPoint(35953700,-83926158), "Access  1", "Access  1"),
			new OverlayItem( new GeoPoint(35954000,-83928200), "Access  2", "Access  2"),
	        new OverlayItem( new GeoPoint(35955000,-83927558), "Access  3", "Access  3"),
	        new OverlayItem( new GeoPoint(35954000,-83927158), "Access  4", "Access  4") 
	};
	
	
	String TAG = "GPStest";
	// Set up the array of GeoPoints defining the route
	int numberRoutePoints;	
	GeoPoint routePoints [];   // Dimension will be set in class RouteLoader below
	int routeGrade [];               // Index for slope of route from point i to point i+1
	RouteSegmentOverlay route;   // This will hold the route segments
	boolean routeIsDisplayed = false;

	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);  // Suppress title bar for more space
        setContentView(R.layout.showthemap);
        
        // Add map controller with zoom controls
        mapView = (MapView) findViewById(R.id.mv);
        mapView.setSatellite(false);
        mapView.setTraffic(false);
        mapView.setBuiltInZoomControls(true);   // Set android:clickable=true in main.xml
        int maxZoom = mapView.getMaxZoomLevel();
        int initZoom = maxZoom-2;
        mapControl = mapView.getController();
        mapControl.setZoom(initZoom);
        // Convert lat/long in degrees into integers in microdegrees
        latE6 =  (int) (lat*1e6);
        lonE6 = (int) (lon*1e6);
        gp = new GeoPoint(latE6, lonE6);
        mapControl.animateTo(gp);    
        
    	// Button to control food overlay
    	overlayButton = (Button)findViewById(R.id.doOverlay);
    	overlayButton.setOnClickListener(new OnClickListener(){      
    	    public void onClick(View v) {	
    	    	setOverlay1();     
    	    }
    	});
    	
    	// Button to control POI overlay
    	accessButton = (Button)findViewById(R.id.doAccess);
    	accessButton.setOnClickListener(new OnClickListener(){      
    	    public void onClick(View v) {	
    	    	setOverlay2();       
    	    }
    	});
    	
    	// Button to control route overlay
    	routeButton = (Button)findViewById(R.id.doRoute);
    	routeButton.setOnClickListener(new OnClickListener(){      
    	    public void onClick(View v) {	
    	    	if(! routeIsDisplayed){
    	    		routeIsDisplayed = true;
    	    		loadRouteData();   				
    	    	} else {
    	    		if(route != null) route.setRouteView(false);
    	    		route = null; // To prevent multiple route instances if key toggled rapidly (see line 235)
    	    		routeIsDisplayed = false;
    	    		mapView.postInvalidate(); 
    	    	}
    	    }
    	}); 
    	
    	AndroidMapUI.getInstance().sendFromActivityToBlock("CREATED", this);
    	
	}
	
	/*
	 * Method for creating Options Menu
	 * @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add("Show Group Members");
		menu.add(0,1,0,"Go To Group Chat");
		return super.onCreateOptionsMenu(menu);
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()){	
		case 0:
			AndroidMapUI.getInstance().sendFromActivityToBlock("REQ_GRP_LOC", this);
		      return true;
		 case 1:
			 String toast = "This will activate the group chat platform";
				Toast.makeText(this, toast, Toast.LENGTH_LONG).show();
				AndroidMapUI.getInstance().sendFromActivityToBlock("GRP_CHAT", this);
		      return true;
		}
		return super.onOptionsItemSelected(item);
    	/*AndroidMapUI.getInstance().sendFromActivityToBlock("REQ_GRP_LOC", this);
		return super.onOptionsItemSelected(item);*/
	}
	
	
	/**
	 * update the overlay for user location update
	 * @param title
	 * @param newLat
	 * @param newLon
	 */
	public void setLocationOverlay(String title, double newLat, double newLon){

		System.out.println("in setLocationOverlay ShowTheMap..");
		
		
		mapOverlays = mapView.getOverlays();
        drawableLoc = this.getResources().getDrawable(R.drawable.user); 
        itemizedOverlayLoc = new MyItemizedOverlay(drawableLoc, getApplicationContext()); 
        
        OverlayItem locItem = new OverlayItem(new GeoPoint( (int) (newLat*1e6), (int) (newLon*1e6)), title, "My Loc y"); 
        
        for (int i = 0; i < itemizedOverlayLoc.size(); i++) {
        	itemizedOverlayLoc.removeItem(i);
		}
        itemizedOverlayLoc.addOverlay(locItem);
        
        mapOverlays.clear();
        mapOverlays.add(itemizedOverlayLoc);
        
        // Start animating the map towards the given point
        mapControl.animateTo(new GeoPoint( (int) (newLat*1e6), (int) (newLon*1e6))); 
        
        // Added symbols will be displayed when map is redrawn so force redraw now
        mapView.postInvalidate();   
	}
	
	/**
	 * Update the overlay for group members location update
	 * @param xml
	 */
	public void setGroupLocationOverlay(String xml){
		System.out.println("setGroupLocationOverlay in ShowTheMap..");
		
		mapOverlays = mapView.getOverlays();
		Drawable drawableGrp = this.getResources().getDrawable(R.drawable.grp_ico); 
		
        itemizedOverlayLoc = new MyItemizedOverlay(drawableGrp, getApplicationContext()); 
        for (int i = 0; i < itemizedOverlayLoc.size(); i++) {
        	itemizedOverlayLoc.removeItem(i);
		}
		mapOverlays.clear();
		
		XStream xstream = new XStream();
		xstream.alias("location", no.ntnu.item.arctis.library.objects.location.Location.class);

		Object o = xstream.fromXML(xml);
		java.util.HashMap<String, no.ntnu.item.arctis.library.objects.location.Location> usersLocations = 
				(HashMap<String, no.ntnu.item.arctis.library.objects.location.Location>) o;

		Set<Entry<String, no.ntnu.item.arctis.library.objects.location.Location>> set = usersLocations.entrySet(); 
		Iterator<Entry<String, no.ntnu.item.arctis.library.objects.location.Location>> i = set.iterator(); 
		while(i.hasNext()) { 
			Map.Entry<String, no.ntnu.item.arctis.library.objects.location.Location> me = 
					(Map.Entry)i.next(); 
			
			System.out.print("Group members locations Key: Value - " + me.getKey() + ": "); 
			System.out.println(((no.ntnu.item.arctis.library.objects.location.Location)me.getValue()).getLatitude() +
					" "+
					((no.ntnu.item.arctis.library.objects.location.Location)me.getValue()).getLongitude()); 
		
			// call loc group overlay method
			String title = me.getKey().toString();
			double newLat = ((no.ntnu.item.arctis.library.objects.location.Location)me.getValue()).getLatitude();
			double newLon = ((no.ntnu.item.arctis.library.objects.location.Location)me.getValue()).getLongitude();
	        OverlayItem locItem = new OverlayItem(new GeoPoint( (int) (newLat*1e6), (int) (newLon*1e6)), title, "group loc"); 
	        itemizedOverlayLoc.addOverlay(locItem);		
		}
		
        mapOverlays.add(itemizedOverlayLoc);
        mapView.postInvalidate();
	}
	
	/**
	 * for food items
	 */
	public void setOverlay1(){	
		int foodLength = foodItem.length;
		// Create itemizedOverlay2 if it doesn't exist and display all three items
		if(! foodIsDisplayed){
	    	mapOverlays = mapView.getOverlays();	
	        drawable1 = this.getResources().getDrawable(R.drawable.knifefork_small); 
	        itemizedOverlay1 = new MyItemizedOverlay(drawable1,getApplicationContext()); 
	        // Display all three items at once
	        for(int i=0; i<foodLength; i++){
	        	itemizedOverlay1.addOverlay(foodItem[i]);
	        }
	        mapOverlays.add(itemizedOverlay1);
	        foodIsDisplayed = !foodIsDisplayed;
	    // Remove each item successively with button clicks
		} else {			
			itemizedOverlay1.removeItem(itemizedOverlay1.size()-1);
			if((itemizedOverlay1.size() < 1))  foodIsDisplayed = false;
		}    
        // Added symbols will be displayed when map is redrawn so force redraw now
        mapView.postInvalidate(); 
	}
	
	
	// Display accessibility overlay.  If not already displayed, successive button clicks display each of
	// the three icons successively, then the next removes them all.  This illustrates the ability to 
	// change individual overlay items dynamically at runtime.
	
	public void setOverlay2(){	
		int accessLength = accessItem.length;
		// Create itemizedOverlay2 if it doesn't exist
		if(itemizedOverlay2 == null ){
    	mapOverlays = mapView.getOverlays();	
        drawable2 = this.getResources().getDrawable(R.drawable.accessibility);
        itemizedOverlay2 = new MyItemizedOverlay(drawable2,getApplicationContext());
		}     
		// Add items with each click
        if(itemizedOverlay2.size() < accessLength){
        	itemizedOverlay2.addOverlay(accessItem[itemizedOverlay2.size()]); 	
        	mapOverlays.add(itemizedOverlay2);      
        // Remove all items with one click
        } else {
        	for(int i=0; i<accessLength; i++){
	        	itemizedOverlay2.removeItem(accessLength-1-i);
	        }
        }     
        // Added symbols will be displayed when map is redrawn so force redraw now
        mapView.postInvalidate();
	}
	
	
	// Method to insert latitude and longitude in degrees
	public static void putLatLong(double latitude, double longitude){
		lat = latitude;
		lon =longitude;
	}
	
	// This sets the s key on the phone to toggle between satellite and map view
	// and the t key to toggle between traffic and no traffic view (traffic view
	// relevant only in urban areas where it is reported).
	/*
	public boolean onKeyDown(int keyCode, KeyEvent e){
		if(keyCode == KeyEvent.KEYCODE_S){
			mapView.setSatellite(!mapView.isSatellite());
			return true;
		} else if(keyCode == KeyEvent.KEYCODE_T){
			mapView.setTraffic(!mapView.isTraffic());
			mapControl.animateTo(gp);  // To ensure change displays immediately
		}
		return(super.onKeyDown(keyCode, e));
	}*/
	
	
	 //display exit dialog and kill everything correct on quit
	public boolean onKeyDown(int keyCode, KeyEvent event) {     
       Log.v("KEYCODE","" + keyCode);
		switch (keyCode) {
       case KeyEvent.KEYCODE_BACK:
       	Log.v("","Exit?");
       	this.showExitDialog();     	
       	break;
       } 
       return super.onKeyDown(KeyEvent.KEYCODE_0, event);
  } 
	
	private void showExitDialog(){	
        this.exitDialog = new Dialog(this);
		this.exitDialog.setOwnerActivity(this);
		this.exitDialog.setTitle("Quit CityPlatform?");
		this.exitDialog.setContentView(R.layout.exitdialog);
		
     	this.exitDialog.findViewById(R.id.YesButton).setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {	 	 			 	
			 	 AndroidMapUI.getInstance().sendFromActivityToBlock("EXIT_FROM_SYSTEM");
			}
		});
     	
       	this.exitDialog.findViewById(R.id.NoButton).setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				exitDialog.dismiss();
			}
		});
       	
       	
       	this.exitDialog.show();	
	}
	
	// Required method since class extends MapActivity
	@Override
	protected boolean isRouteDisplayed() {
		return false;  // Don't display a route
	}
	
	
    // Method to read route data from server as XML
    
    public void loadRouteData(){
    	try {
    		String url = "http://eagle.phys.utk.edu/reubendb/UTRoute.php";
    		String data = "?lat1=35952967&lon1=-83929158&lat2=35956567&lon2=-83925450";
    		//RouteLoader RL = new RouteLoader();
    		//RL.execute(new URL(url+data));
    		new RouteLoader().execute(new URL(url+data));
        } catch (MalformedURLException e) {
            Log.i("NETWORK", "Failed to generate valid URL");
        }
    }
	
	// Overlay a route.  This method is only executed after loadRouteData() completes
    // on background thread.
    
    public void overlayRoute() {
    	if(route != null) return;  // To prevent multiple route instances if key toggled rapidly (see also line 116)
    	// Set up the overlay controller
    	route = new RouteSegmentOverlay(routePoints, routeGrade); // My class defining route overlay
    	mapOverlays = mapView.getOverlays();
    	mapOverlays.add(route);
    	
    	// Added symbols will be displayed when map is redrawn so force redraw now
        mapView.postInvalidate(); 
    }
    
    
    
    //bring this to top
    public void bringItFront(){
    	System.out.println("in bringItFront..");
    	
    	Intent intent = getIntent();
		//intent.setFlags(android.content.Intent.FLAG_ACTIVITY_CLEAR_TOP);
		//intent.setFlags(android.content.Intent.FLAG_ACTIVITY_NEW_TASK);
    	intent.setFlags(android.content.Intent.FLAG_ACTIVITY_BROUGHT_TO_FRONT);
    	startActivity(intent);
        
    	
    }
    
    
    
    /* Class to implement single task on background thread without having to manage
	the threads directly. Launch with "new RouteLoader().execute(new URL(urlString)". 
	Must be launched from the UI thread and may only be invoked once. Use this to do data 
	load from network on separate thread from main user interface to prevent locking
	main UI if there is network delay. */
	
	private class RouteLoader extends AsyncTask<URL, String, String> {

		 @Override
	        protected String doInBackground(URL... params) {
	            // This pattern takes more than one param but we'll just use the first
	            try {
	                URL text = params[0];

	                XmlPullParserFactory parserCreator;

	                parserCreator = XmlPullParserFactory.newInstance();

	                XmlPullParser parser = parserCreator.newPullParser();

	                parser.setInput(text.openStream(), null);

	                publishProgress("Parsing XML...");

	                int parserEvent = parser.getEventType();
	                int pointCounter = -1;
	                int wptCounter = -1;
	                int totalWaypoints = -1;
	                int lat = -1;
	                int lon = -1;
	                String wptDescription = "";
	                int grade = -1;
	                
	                // Parse the XML returned on the network
	                while (parserEvent != XmlPullParser.END_DOCUMENT) {
	                    switch (parserEvent) {
	                    case XmlPullParser.START_TAG:
	                        String tag = parser.getName();
	                        if(tag.compareTo("number")==0){
	                        	numberRoutePoints = Integer.parseInt(parser.getAttributeValue(null,"numpoints"));
	                        	totalWaypoints = Integer.parseInt(parser.getAttributeValue(null,"numwpts"));
	                        	routePoints = new GeoPoint[numberRoutePoints]; 
	                        	routeGrade = new int[numberRoutePoints];
	                        	Log.i(TAG, "   Total points = "+numberRoutePoints
	                        			+" Total waypoints = "+totalWaypoints);
	                        }
	                        if(tag.compareTo("trkpt")==0){
	                        	pointCounter ++;
	                        	lat = Integer.parseInt(parser.getAttributeValue(null,"lat"));
	                        	lon = Integer.parseInt(parser.getAttributeValue(null,"lon"));
	                        	grade = Integer.parseInt(parser.getAttributeValue(null,"grade"));
	                        	routePoints[pointCounter] = new GeoPoint(lat, lon);
	                        	routeGrade[pointCounter] = grade;
	                        	Log.i(TAG,"   trackpoint="+pointCounter+" latitude="+lat+" longitude="+lon
	                        			+" grade="+grade);
	                        } else if(tag.compareTo("wpt")==0) {
	                        	wptCounter ++;
	                        	lat = Integer.parseInt(parser.getAttributeValue(null,"lat"));
	                        	lon = Integer.parseInt(parser.getAttributeValue(null,"lon"));
	                        	wptDescription = parser.getAttributeValue(null,"description");
	                        	Log.i(TAG,"   waypoint="+wptCounter+" latitude="+lat+" longitude="+lon
	                        			+" "+wptDescription);                      	
	                        } 
	                        break;
	                    }

	                    parserEvent = parser.next();
	                }

	            } catch (Exception e) {
	                Log.i("RouteLoader", "Failed in parsing XML", e);
	                return "Finished with failure.";
	            }

	            return "Done...";
	        }

	        protected void onCancelled() {
	            Log.i("RouteLoader", "GetRoute task Cancelled");
	        }

	        // Now that route data are loaded, execute the method to overlay the route on the map
	        protected void onPostExecute(String result) {
	        	Log.i(TAG, "Route data transfer complete");
	        	overlayRoute();
	        }

	        protected void onPreExecute() {
	            Log.i(TAG,"Ready to load URL");
	        }

	        protected void onProgressUpdate(String... values) {
	            super.onProgressUpdate(values);
	        }

	}
	

}
