package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp;

import no.ntnu.item.arctis.runtime.IStateMachine;
import no.ntnu.item.arctis.runtime.Runtime;
import no.ntnu.item.arctis.runtime.Register;
import no.ntnu.item.arctis.runtime.IRegister;
import no.ntnu.item.arctis.runtime.Scheduler;

public class MyRuntime extends Runtime {

	private MyRuntime(IRegister register) {
		super(register);
	}

    public static Runtime create() {
        MyRuntime runtime = new MyRuntime(new Register());
        return runtime;
    }

	protected IStateMachine createDefaultStateMachine(Scheduler scheduler) {
		return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.AppSM(scheduler, null, null);
	}

	protected IStateMachine createSession(String signalID, Scheduler scheduler, String sessionID, String parentSessionID) {
        if("_c2_c4_c1_IM_Service_Proxy_start".equals(signalID)) {
            return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.IMServiceProxySM(scheduler, sessionID, parentSessionID);
        } else if("_c2_City_Guide_UI_start".equals(signalID)) {
		    return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.CityGuideUISM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c1_Location_Aware_Quiz_Service_register".equals(signalID)) {
		    return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.LocationAwareQuizServiceSM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c5_c1_GroupChat_Service_Proxy_start".equals(signalID)) {
		    return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.GroupChatServiceProxySM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c5_GroupChat_App_start".equals(signalID)) {
		    return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.GroupChatAppSM(scheduler, sessionID, parentSessionID);
        } else if("_c1_Login_App_start".equals(signalID)) {
		    return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.LoginAppSM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c4_IM_App_start".equals(signalID)) {
		    return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.IMAppSM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c0_Location_Service_register".equals(signalID)) {
		    return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.LocationServiceSM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c2_Android_Map_UI_start".equals(signalID)) {
		    return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.AndroidMapUISM(scheduler, sessionID, parentSessionID);
        } else if("_c2_c3_Group_Positioning_Service_Proxy_start".equals(signalID)) {
		    return new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.GroupPositioningServiceProxySM(scheduler, sessionID, parentSessionID);
        }
        return null;
    }

	protected boolean createsSession(String signalID) {
        if("_c2_c4_c1_IM_Service_Proxy_start".equals(signalID)) {
            return true;
        } else if("_c2_City_Guide_UI_start".equals(signalID)) {
            return true;
        } else if("_c2_c1_Location_Aware_Quiz_Service_register".equals(signalID)) {
            return true;
        } else if("_c2_c5_c1_GroupChat_Service_Proxy_start".equals(signalID)) {
            return true;
        } else if("_c2_c5_GroupChat_App_start".equals(signalID)) {
            return true;
        } else if("_c1_Login_App_start".equals(signalID)) {
            return true;
        } else if("_c2_c4_IM_App_start".equals(signalID)) {
            return true;
        } else if("_c2_c0_Location_Service_register".equals(signalID)) {
            return true;
        } else if("_c2_c2_Android_Map_UI_start".equals(signalID)) {
            return true;
        } else if("_c2_c3_Group_Positioning_Service_Proxy_start".equals(signalID)) {
            return true;
        }
        return false;
    }

}
