package no.ntnu.item.arctis.examples.android.cityguide.serverconnectiondialog;

import no.ntnu.item.arctis.android.R;
import no.ntnu.item.arctis.examples.android.cityguide.androidmapui.AndroidMapUI;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;

public class ServerConnectionActivity extends Activity {

	private static ServerConnectionActivity serverConnectionActivity;

	private android.app.Dialog connDialog;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		//ServerConnectionDialog.getInstance().sendFromActivityToBlock("CREATED", this);		
		serverConnectionActivity = this;

		showServerConnectionSettingAlert();
	}

	/*
	 * A method to show a dialog that allows to change the server configuration
	 */
	private void showServerConnectionSettingAlert(){

		this.connDialog = new android.app.Dialog(this);
		this.connDialog.setOwnerActivity(this);
		this.connDialog.setTitle("Enter Server IP Address");
		this.connDialog.setContentView(R.layout.server_conn_dialog_new);

		this.connDialog.findViewById(R.id.buttonServerConnect).setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {	 

				EditText mUserText = (EditText) connDialog.findViewById(R.id.ALERT_DIALOG_EDIT_TEXT); 
				//mUserText.setText("fabula.idi.ntnu.no");
				String newMsg = mUserText.getText().toString();
				if(ServerConnectionDialog.getInstance()!=null){
					ServerConnectionDialog.getInstance().sendFromActivityToBlock("SERVER_ADDRESS", newMsg, serverConnectionActivity);
				}
			}
		});

		this.connDialog.findViewById(R.id.buttonServerConnectCancel).setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				
				if(ServerConnectionDialog.getInstance()!=null){
					ServerConnectionDialog.getInstance().backKeyClicked("BACK", serverConnectionActivity);
				}
				
				connDialog.dismiss();
			}
		});

		this.connDialog.setOnKeyListener(new DialogInterface.OnKeyListener() {

			@Override
			public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
				// TODO Auto-generated method stub
				Log.v("ON DIALOG KEYCODE","" + keyCode);
				switch (keyCode) {
				case KeyEvent.KEYCODE_BACK:
					if(connDialog.isShowing()){
						Log.v("","Exit Server Connection Dialog?");  
						if(ServerConnectionDialog.getInstance() != null){
							ServerConnectionDialog.getInstance().backKeyClicked("BACK", serverConnectionActivity);
						}
						connDialog.dismiss();
					}

					break;
				} 
				
				return false;
				
			}
		});
		//	onBackPressed();

		this.connDialog.show();	

		/*			
		LayoutInflater infalter = LayoutInflater.from(this);  
		final View textEntryView = infalter.inflate(R.layout.server_conn_dialog, null);  
		AlertDialog.Builder dialogBuilder = new AlertDialog.Builder(this);  
		dialogBuilder.setTitle("Server IP Address");  
		dialogBuilder.setView(textEntryView);  		
		dialogBuilder.setPositiveButton("Connect", new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialog, int which)   
			{  				
				EditText mUserText = (EditText) textEntryView.findViewById(R.id.ALERT_DIALOG_EDIT_TEXT); 
				String newMsg = mUserText.getText().toString();

				// TODO send the changed spec to ActorRouter
				//ActorframeContainer.getContext().applicationSpecChanged(newMsg);

				// TODO update the userspec file
				ServerConnectionDialog.getInstance().sendFromActivityToBlock("SERVER_ADDRESS", newMsg, serverConnectionActivity);
				//finish();
			}  

		});

		dialogBuilder.setNegativeButton("Cancel", new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialog, int which)   
			{  				
				return;
			}  

		});

		dialogBuilder.show();		

		 */

	}


	//finish activity if BACK KEY is pressed
	public boolean onKeyDown(int keyCode, KeyEvent event) {     
		Log.v("KEYCODE","" + keyCode);
		switch (keyCode) {
		case KeyEvent.KEYCODE_BACK:
				Log.v("","Exit Server Connection Activity?");  
				if(ServerConnectionDialog.getInstance() !=null){
					ServerConnectionDialog.getInstance().backKeyClicked("BACK", serverConnectionActivity);
				}				
				connDialog.dismiss();
			break;
		} 
		return super.onKeyDown(KeyEvent.KEYCODE_0, event);
	}
	
	public android.app.Dialog getServerConnDialog(){
		return this.connDialog;
	}
}
