package no.ntnu.item.arctis.library.proxies.proxyhost;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class ProxyHost extends Block {
	
	static ProxyHost instance;

	public static interface MessageListener {
		public void receive(Message message);
	}

	private static Map<String,MessageListener> listeners = new HashMap<String, ProxyHost.MessageListener>();
	public no.ntnu.item.arctis.library.proxies.Message message;
	public no.ntnu.item.arctis.library.proxies.Address local;
	// Instance parameter. Edit only in overview page.
	public final java.lang.String type;
	
	public static final void register(String sessionID, MessageListener listener) {
		if(listeners.containsKey(sessionID)) {
			// TODO warn
		}
		System.err.println("register listener on " + sessionID);
		listeners.put(sessionID, listener);
	}
	
	public static final void send(Message message) {
		assert instance!=null;
		assert message.getReceiver()!=null;
		assert message.getSender()!=null;
		System.err.println("send message: " + message.getSignalID());
		instance.sendToBlock("OUTBOUND", message);
	}
	
	public void receive(Message message) {
		System.err.println("route message: " + message.getSignalID());
		MessageListener listener = listeners.get(message.getReceiver().getSessionID());
		if(listener!=null) {
			listener.receive(message);
		} else {
			System.err.println("Message discarded!" + message.getSignalID() + " " + message.getReceiver().getSessionID());
		}
	}

	public static void deregister(String sessionID) {
		listeners.remove(sessionID);
	}

	public boolean isLocal() {
	
		if(message.getSignalID().equalsIgnoreCase("register") | message.getSignalID().equalsIgnoreCase("discover")){
			if(type.split("-")[0].equalsIgnoreCase("client") | type.split("-")[0].equalsIgnoreCase("AndroidClient")){
				return false;
			}
		}
		
		else if(message.getSignalID().equalsIgnoreCase("ok")){
			if(type.split("-")[0].equalsIgnoreCase("server")){
				return false;
			}
		}
		
		else {
			System.out.println("message.getReceiver().getSessionID() "+ message.getReceiver().getSessionID());
			Iterator<String> it = listeners.keySet().iterator();
			boolean r = false;
			String[] str = message.getReceiver().getSessionID().split("_");
			String str1 = str[0];
			while(it.hasNext()){
				String str2 = it.next().split("_")[0];

				if(str1.equalsIgnoreCase(str2)){
					System.out.println("matched....");
					r = true;
					break;
				}
			}
			return r;
		}
		
		return local.getIP().equals(message.getReceiver().getIP()) && local.getPort().equals(message.getReceiver().getPort());
	}

	public void stop() {
		listeners.clear();
	}

	// Do not edit this constructor.
	public ProxyHost(java.lang.String type) {
	    this.type = type;
	    instance = this;
	}

	public String getProxyType() {
		return type;
	}

}
