package no.ntnu.item.arctis.runtime.android;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.Block;
import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Handler;
import android.preference.PreferenceManager;

public class AndroidBlock extends Block {

	public Context getContext() {
		return (Context) AbstractRuntime.getRuntime().getContext("Android");
	}

	public Handler getHandler() {
		return (Handler) AbstractRuntime.getRuntime().getContext("Handler");
	}

	public SharedPreferences getPreferences() {
		return PreferenceManager.getDefaultSharedPreferences((Context) AbstractRuntime.getRuntime().getContext("Android"));
	}

	public Context getCurrentActivityContext() {
		Context c = (Context) AbstractRuntime.getRuntime().getContext("CurrentActivity");
		if (c == null) {
			return getContext();
		}
		return c;
	}

	public static void setCurrentActivityContext(Activity active, String blockID) {
		AbstractRuntime.getRuntime().addContext("CurrentActivity", active);
	}

}
