package no.ntnu.item.arctis.runtime.android;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.Block;
import no.ntnu.item.arctis.runtime.Runtime;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Handler;
import android.os.IBinder;
import android.telephony.TelephonyManager;


public abstract class GeneralStartService2 extends android.app.Service {

	private Runtime runtime;

	public void onCreate() {
		super.onCreate();
	}

	protected abstract Runtime createRuntime();

	public IBinder onBind(Intent intent) {
		return null;
	}

	public int onStartCommand(Intent intent, int flags, int startId) {
		System.err.println(" OOOOO onStartCommand of service called.");
		if(runtime==null || !runtime.isRunning()) {
			System.err.println("  --> runtime is " + runtime==null?"null":"not running" + "... starting it again");
			runtime = createRuntime();
			runtime.setContext("Android", this);
			Handler arctisUpdateHandler = new Handler();
			runtime.setContext("Handler", arctisUpdateHandler);
			//runtime.setContext("ServiceController", (ForegroundController) this);
			runtime.addContext("wrapping", "service");
			String imei = ((TelephonyManager)getApplicationContext().getSystemService(Context.TELEPHONY_SERVICE)).getDeviceId();
			runtime.addContext(Block.DEVICE_ID, imei);
			runtime.addContext("package", getApplicationInfo().packageName);
			try {
				String versionName = getPackageManager().getPackageInfo(getPackageName(), 0).versionName;
				runtime.addContext("version", versionName);
			} catch (NameNotFoundException e) {
				e.printStackTrace();
			}
			runtime.setTerminationListener(new Runtime.IRuntimeTerminationListener() {
				public void runtimeStopped() {
					System.err.println(" OOOOO Stopping service since runtime terminated.");
					GeneralStartService2.this.stopSelf();
				}
			});
			runtime.start();
		} else {
			System.err.println("  --> runtime is running");
			String reactivationBlockID = (String) AbstractRuntime.getRuntime().getContext("reactivationBlockID");
			String reactivationSessionID = (String) AbstractRuntime.getRuntime().getContext("reactivationSessionID");
			
			System.err.println("  REACTIVATE: " + reactivationBlockID);
			System.err.println("  REACTIVATE: " + reactivationSessionID);
			
			if(reactivationBlockID!=null /*&& reactivationSessionID!=null*/) {
				AbstractRuntime.getRuntime().sendToBlock(reactivationSessionID, reactivationBlockID, "REACTIVATE_" + reactivationBlockID);
			} else {
				System.err.println("  --> could not reactivate UI. Make sure that the building block 'Startup' is used.");
			}
		}
		return super.onStartCommand(intent, flags, startId);
	}

	public void onDestroy() {
		System.err.println(" OOOOO service: onDestroy");
		if(runtime!=null && runtime.isRunning()) {
			runtime.stop();
			System.err.println("       --> stopped runtime ");
		}
		super.onDestroy();
	}



}