package no.ntnu.item.arctis.runtime.android;

import java.util.HashMap;
import java.util.Map;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import android.app.Activity;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;

public class InvisibleActivity extends Activity implements IStartActivity {

	private boolean createdPreviously = false;
	
	public static final String BLOCK_ID_EXTRA_KEY = "BLOCK_ID_EXTRA_KEY";
	public static final String SESSION_ID_EXTRA_KEY = "SESSION_ID_EXTRA_KEY";
	
	public void onCreate(Bundle savedInstanceState) {
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		//setTheme(android.R.style.Theme_Dialog);
		setVisible(false);
		super.onCreate(savedInstanceState);
		if (!createdPreviously) {
			String blockID = getIntent().getStringExtra(BLOCK_ID_EXTRA_KEY);
			String sessionID = getIntent().getStringExtra(SESSION_ID_EXTRA_KEY);
			AbstractRuntime.getRuntime(blockID).sendToBlock(sessionID, blockID, "CREATED_" + blockID, this);
			createdPreviously = true;
		}
	}
	
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		IActivityResultListener listener = map.get(requestCode);
		if(listener!=null) {
			listener.onActivityResult(resultCode, data);
		}
        super.onActivityResult(requestCode, resultCode, data);
        finish();
	}
	
	private Map<Integer,IActivityResultListener> map = new HashMap<Integer, IActivityResultListener>();
	
	public void registerOnActivityResultListener(int requestCode, IActivityResultListener listener) {
		map.put(requestCode, listener);
	}
	
	
}