package no.ntnu.item.arctis.examples.android.cityguide.androidquizui;

import java.util.Iterator;
import java.util.Vector;

import no.ntnu.item.arctis.android.R;
import no.ntnu.item.arctis.library.objects.quiz.Answer;
import no.ntnu.item.arctis.library.objects.quiz.Question;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.TextView;

import com.thoughtworks.xstream.XStream;
import no.ntnu.item.arctis.library.objects.quiz.SessionOption;
import no.ntnu.item.arctis.library.objects.quiz.SessionQuestion;


public class AndroidQuizUI extends AndroidBlock {

	public android.app.Activity activity;
	private Button ansButton;
	private TextView questionText;
	private RadioButton opt1Text, opt2Text, opt3Text;


	private static AndroidQuizUI androidQuizUI;

	public boolean isQuizActive;

	public int index = 0;

	public java.util.Vector<SessionQuestion> questions;
	public java.lang.String summary;

	public AndroidQuizUI() {
		// TODO Auto-generated constructor stub
		androidQuizUI=this;
	}

	public static AndroidQuizUI getInstance(){
		return androidQuizUI;
	}

	public void startUI() {
		System.out.println("starting AndroidQuizUI");
	}

	public void updateQuestion(int index) {
	
		System.out.println("in updateQuestion..");

		if(this.index == 0){
			QuizActivity qa = (QuizActivity)this.activity;
			
			/*
			if(qa.getCurrentFocus() == null) {
				System.out.println("is not in Focus and bringing back to focus");
				qa.bringItFront();
			}*/
						
			this.ansButton = (Button) qa.findViewById(R.id.buttonAnswer);		
			this.questionText = (TextView) qa.findViewById(R.id.textQuestion);
			this.opt1Text = (RadioButton) qa.findViewById(R.id.radio0);
			this.opt2Text = (RadioButton) qa.findViewById(R.id.radio1);
			this.opt3Text = (RadioButton) qa.findViewById(R.id.radio2);
		}

		final SessionQuestion sq = this.questions.elementAt(index);
		//qa.updateGui(sq);

		Runnable r = new Runnable() {
			public void run() {			
				System.out.println("Updating quiz activity UI Runnable..");
				questionText.setText(sq.getQuestionText().elementAt(0));
				opt1Text.setText(sq.getOptions().elementAt(0).getAnswerOption());
				opt2Text.setText(sq.getOptions().elementAt(1).getAnswerOption()) ;
				opt3Text.setText(sq.getOptions().elementAt(2).getAnswerOption()) ;	
			}
		};
		getHandler().post(r);
	}

	public void sendFromActivityToBlock(String signal, Object data){
		sendToBlock(signal,data);
	}

	public void sendFromActivityToBlock(String signal){
		sendToBlock(signal);
	}

	public Vector<SessionQuestion> initQuestions(Question ques) {

		System.out.println("in initQuestions..");
		XStream xstream = new XStream();
		xstream.alias("sessionquestion", SessionQuestion.class);
		xstream.alias("sessionoption", SessionOption.class);

		//Object[] o_ = (Object[]) xstream.fromXML(ques.getQuestioText());

		Object o = xstream.fromXML(ques.getQuestioText());
		Vector<SessionQuestion> questions_ = (Vector<SessionQuestion>) o;

		this.index = 0;
		this.summary = "";
		
		return questions_;
	}

	public void startActivity() {

		System.out.println("in startActivity..");

		android.content.Intent intent = new android.content.Intent((android.content.Context)getProperty("androidContext"), QuizActivity.class);
		intent.setFlags(android.content.Intent.FLAG_ACTIVITY_NEW_TASK);
		((android.content.Context) getProperty("androidContext")).startActivity(intent);
	}

	public boolean checkFinished(Answer a) {

		System.out.println("in checkFinished..");
		
		// create summary also
		SessionQuestion sq_ = this.questions.elementAt(this.index);
		String corrAns_ = sq_.getOptions().elementAt(sq_.getCorrectAnswerIndex()).getAnswerOption();
		String rcvdAns_ = a.getAnswerText();
		
		//if(rcvdAns_.equalsIgnoreCase(corrAns_))
		{
			System.out.println("Creating summary...");
			this.summary = this.summary + "\n" +
					"Question: " + sq_.getQuestionText() + "\n"+
					"Your Ans: " + rcvdAns_ + "\n"+
					"Corr Ans: " + corrAns_;
		}
			
		
		if(this.index+1>=this.questions.size()) return true;
		else return false;
	}

	public void incrIndex() {
		System.out.println("in incrIndex..");
		this.index = this.index + 1;
	}

	public Answer qaFinished() {
		System.out.println("in qaFinished..");

		Answer a = new Answer();
		a.setAnswerText(this.summary);
		
		((QuizActivity) activity).finish();
		
		return a;
	}

	public boolean checkActExists() {
		/*if(activity!=null) return true;
		else return false;*/
		return false;
	}

	public void showSummary() {		
		Runnable r = new Runnable() {
			public void run() {	
				AlertDialog dialog=new AlertDialog.Builder(activity).create();
				dialog.setTitle("Congratulations!!");
				dialog.setMessage(summary);
				dialog.setButton("Continue",
						new DialogInterface.OnClickListener()
				{
					public void onClick(DialogInterface dialog, int whichButton)
					{
						sendToBlock("CONTINUE");
					}
				});
				dialog.show();
			}
		};
		getHandler().post(r);
	}

}
