package no.ntnu.item.arctis.examples.android.cityguide.androidquizui;

import no.ntnu.item.arctis.android.R;
import no.ntnu.item.arctis.library.objects.quiz.Answer;
import no.ntnu.item.arctis.library.objects.quiz.SessionQuestion;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

public class QuizActivity extends Activity implements OnClickListener{

	private Button ansButton;
	private TextView questionText;
	private RadioButton opt1Text, opt2Text, opt3Text;
	private RadioGroup optRadioGroup;
		
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		//check which of the two buttons is pressed
		boolean isOk =(v.getId() == R.id.buttonAnswer);
		
		if(isOk){
			// get the selected radio button, compose answer message, send to the block
			System.out.println("Answer button is clicked.....");
			
			Answer ans = new Answer();
		
			int r_id = this.optRadioGroup.getCheckedRadioButtonId();
			String ansText = "answer is clicked..";
			if(r_id == opt1Text.getId()){
				ansText = opt1Text.getText().toString();
			} else if(r_id == opt2Text.getId()){
				ansText = opt2Text.getText().toString();
			} else if(r_id == opt3Text.getId()){
				ansText = opt3Text.getText().toString();
			}
			ans.setAnswerText(ansText);
			
			AndroidQuizUI.getInstance().sendFromActivityToBlock("ANSWER", ans);
		}
		
	}
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);	
		setContentView(R.layout.quiz);
		
		this.ansButton = (Button) findViewById(R.id.buttonAnswer);
		ansButton.setOnClickListener( this);
		
		this.questionText = (TextView) findViewById(R.id.textQuestion);
		this.optRadioGroup = (RadioGroup)findViewById(R.id.radioGroup1);
		this.opt1Text = (RadioButton) findViewById(R.id.radio0);
		this.opt2Text = (RadioButton) findViewById(R.id.radio1);
		this.opt3Text = (RadioButton) findViewById(R.id.radio2);
		
		//updateGui();
		
		AndroidQuizUI.getInstance().sendFromActivityToBlock("CREATED", this);
	}
	
	
	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
	}
	
	
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
	}
	
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
	}
	
	public void updateGui(){	
		System.out.println("Updating quiz activity UI 1..");
		questionText.setText("");//(TextView) findViewById(R.id.textQuestion);
		opt1Text.setText(""); //(RadioButton) findViewById(R.id.radio0);
		opt2Text.setText("") ; //(RadioButton) findViewById(R.id.radio1);
		opt3Text.setText("") ;// (RadioButton) findViewById(R.id.radio2);	
	}
	
	public void bringItFront(){
	    android.content.Intent intent = getIntent();
		//intent.setFlags(android.content.Intent.FLAG_ACTIVITY_CLEAR_TOP);
		//intent.setFlags(android.content.Intent.FLAG_ACTIVITY_NEW_TASK);
    	intent.setFlags(android.content.Intent.FLAG_ACTIVITY_BROUGHT_TO_FRONT);
    	startActivity(intent);
	}
	
}
