package no.ntnu.item.arctis.library.android.location.androidservicecontroller;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

public class AndroidServiceController implements IArctisBuildingBlock {

	public Context context;
	public String blockID;
	public android.os.Handler arctisUpdateHandler;
	private final String TAG = "AndroidServiceController";
	public android.content.Intent serviceIntent;

	public void startupService(Intent serviceIntent) {
		Log.d(TAG, TAG + ":startupService");
		context.startService(serviceIntent);
	}

	public void setBlockID(String ID) {
		this.blockID = ID;

	}

	public Intent configureServiceIntent(Class theService) {
		Log.d(TAG, TAG + ":configureServiceIntent");

		context = (Context) AbstractRuntime.getRuntime(blockID).getContext("Android");

		serviceIntent = new Intent(context, theService);

		serviceIntent.putExtra("BLOCK_ID", blockID);

		/*
		 * CONFIGURE TIME AND DISTANCE BUT REMEMBER THAT THIS WILL AFFECT ALL
		 * SYSTEMS USING THIS BLOCK
		 */
		int time = 0; // time in microseconds
		int distance = 0; // distance in meter
		/*
		 * END CONFIGURE
		 */
		serviceIntent.putExtra("time", time);
		serviceIntent.putExtra("distance", distance);

		return serviceIntent;
	}

	public void stopService(Intent serviceIntent) {
		Log.d(TAG, TAG + ":stopService!!!");
		context.stopService(serviceIntent);
	}

	@Override
	public void setBlockID(String blockID, String sessionID) {
		// TODO Auto-generated method stub
		
	}

}