package no.ntnu.item.arctis.library.android.location.enablegps;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;
import android.content.Context;
import android.content.Intent;
import android.location.LocationManager;
import android.location.LocationProvider;

public class EnableGPS implements IArctisBuildingBlock {

	private String blockID;

	public Context context;
	public LocationManager locManager;
	private LocationProvider locationProvider;

	public boolean isGPSEnabled() {
		if (locManager.isProviderEnabled(LocationManager.GPS_PROVIDER)) {
			return true;
		} else {
			return false;
		}
	}

	public boolean isSupported() {
		context = (Context) AbstractRuntime.getRuntime(blockID).getContext("Android");
		locManager = (LocationManager) context.getSystemService(Context.LOCATION_SERVICE);
		locationProvider = locManager.getProvider(LocationManager.GPS_PROVIDER);
		if (locationProvider != null) {
			return true;
		} else {
			return false;
		}
	}

	public void showLocationSettings() {
		context = (Context) AbstractRuntime.getRuntime(blockID).getContext("Android");
		context.startActivity(new Intent("android.settings.LOCATION_SOURCE_SETTINGS"));
	}

	public void setBlockID(String ID) {
		this.blockID = ID;
	}

	@Override
	public void setBlockID(String blockID, String sessionID) {
		// TODO Auto-generated method stub
		
	}
}