package no.ntnu.item.arctis.library.android.location.geocodefromplacename;

import java.io.IOException;
import java.util.List;
import java.util.Locale;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;
import android.content.Context;
import android.location.Address;
import android.location.Geocoder;
import android.location.Location;
import android.util.Log;

public class GeocodeFromPlacename implements IArctisBuildingBlock {

	private final String TAG = "GeocodeFromPlacename";

	private String blockID;
	private String sessionID;

	public void geocode(final String placeName) {
		Thread t = new Thread() {
			public void run() {
				if (placeName != null) {
					Context context = (Context) AbstractRuntime.getRuntime(blockID).getContext("Android");
					Geocoder gc = new Geocoder(context, Locale.getDefault());
					try {
						Log.d(TAG, TAG + ":Geocode, try " + placeName);
						List<Address> addresses = gc.getFromLocationName(placeName, 1);
						if (addresses.size() > 0) {
							Address address = addresses.get(0);
							AbstractRuntime.getRuntime(blockID).sendToBlock(sessionID,blockID, "ADDRESS" + "_" + blockID, address);
						} else {
							AbstractRuntime.getRuntime(blockID).sendToBlock(sessionID,blockID, "NO_ADDRESS" + "_" + blockID);
						}
					} catch (IOException e) {
						Log.d(TAG, TAG + "IOException");
						AbstractRuntime.getRuntime(blockID).sendToBlock(sessionID,blockID, "NO_ADDRESS" + "_" + blockID);
					}
				}
			}
		};
		t.start();
	}

	public void setBlockID(String ID) {
		this.blockID = ID;

	}

	public Location addressToLocation(Address address) {
		Location loc = new Location("gps");
		Log.d(TAG, TAG + "addressToLocation-latitude: " + address.getLatitude());
		loc.setLatitude(address.getLatitude());
		loc.setLongitude(address.getLongitude());

		return loc;
	}

	@Override
	public void setBlockID(String blockID, String sessionID) {
		// TODO Auto-generated method stub
		
	}

}