package no.ntnu.item.arctis.library.android.location.getcurrentlocation3;

import no.ntnu.item.arctis.library.android.location.getcurrentlocation3.MyLocation.LocationResult;
import no.ntnu.item.arctis.runtime.AbstractRuntime;
import android.app.Service;
import android.content.Intent;
import android.location.Location;
import android.os.IBinder;

public class TheCurrentLocationService extends Service {

	public String blockID;
	private String sessionID;
	protected boolean foundLocation = false;
    MyLocation myLocation = new MyLocation(20000);

    LocationResult locationResult = new LocationResult(){
        @Override
        public void gotLocation(Location location){
        	if (location != null) {
        		sendSignalToArctisWithObject("LOCATION_CHANGED", location);
        		foundLocation = true;
        	} else {
        		sendSignalToArctis("LOCATION_NOT_FOUND");
        	}
			stopSelf();
        }
    };


    public TheCurrentLocationService() {
		// TODO Auto-generated constructor stub
	}

	public void onCreate() {
		super.onCreate();
	}

	public void onStart(Intent intent, int startId) {
		// Actions to perform when service is started.
		blockID = intent.getStringExtra("BLOCK_ID");

		if (!myLocation.anyProviderEnabled(this)) {
			sendSignalToArctis("PROVIDER_DISABLED");
			stopSelf();
		}

        myLocation.getLocation(locationResult);

        super.onStart(intent, startId);
	}

	public void onDestroy() {
		myLocation.removeListeners();
		if (!foundLocation) {
			sendSignalToArctis("onDestroy");
		}
		// stopSelf();
		super.onDestroy();
	}

	public IBinder onBind(Intent intent) {
		return null;
	}

	private void sendSignalToArctis(String signalName) {
		AbstractRuntime.getRuntime(blockID).sendToBlock(sessionID,blockID, signalName + "_" + blockID);
	}

	private void sendSignalToArctisWithObject(String signalName, Object obj) {
		AbstractRuntime.getRuntime(blockID).sendToBlock(sessionID,blockID, signalName + "_" + blockID, obj);
	}

}
