package no.ntnu.item.arctis.library.android.location.periodiclocationupdates;

/*
 <service class="LocationService" android:name="no.ntnu.item.arctis.library.android.location.periodiclocationupdates.TheLocationService" \>
 */

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

public class PeriodicLocationUpdates implements IArctisBuildingBlock {

	public android.os.Handler arctisUpdateHandler;
	public android.content.Intent serviceIntent;
	public String blockID;
	private final String TAG = "PeriodicLocationUpdates";
	public Context context;

	public Class getLocationService() {
		return TheLocationService.class;
	}

	public Intent configureServiceIntent(Class theService) {
		Log.d(TAG, TAG + ":configureServiceIntent");

		context = (Context) AbstractRuntime.getRuntime(blockID).getContext("Android");

		serviceIntent = new Intent(context, theService);
		serviceIntent.putExtra("BLOCK_ID", blockID);
		/*
		 * CONFIGURE TIME AND DISTANCE BUT REMEMBER THAT THIS WILL AFFECT ALL
		 * SYSTEMS USING THIS BLOCK
		 */
		int time = 60000; // time in microseconds
		int distance = 20; // distance in meter
		/*
		 * END CONFIGURE
		 */
		serviceIntent.putExtra("time", time);
		serviceIntent.putExtra("distance", distance);

		return serviceIntent;
	}

	public void setBlockID(String ID) {
		this.blockID = ID;
	}

	public void startService() {
		Log.d(TAG, TAG + ":startupService");

		// Start service method 1
		context.startService(serviceIntent);
	}

	public void stopService() {
		Log.d(TAG, TAG + ":stopService!!!");
		context.stopService(serviceIntent);
	}

	@Override
	public void setBlockID(String blockID, String sessionID) {
		// TODO Auto-generated method stub
		
	}

}