package no.ntnu.item.arctis.library.android.location.proximitylistener;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.location.Location;
import android.location.LocationManager;

public class ProximityListener implements IArctisBuildingBlock {

	public LocationManager locManager;
	public String blockID;
	public Context context;
	public PendingIntent pendingIntent = null;
	public Intent intent;

	public void registerProximityAlert(Location loc) {
		context = (Context) AbstractRuntime.getRuntime(blockID).getContext("Android");
		locManager = (LocationManager) context.getSystemService(Context.LOCATION_SERVICE);

		if (pendingIntent != null) {
			locManager.removeProximityAlert(pendingIntent);
		}

		/*
		 * CONFIGURE Proximity Alert FORMAT: locManager.addProximityAlert(double
		 * latitude, double longitude, float radius, long expiration,
		 * PendingIntent intent);
		 */

		intent = new Intent("PROXIMITY_ALERT");
		pendingIntent = PendingIntent.getBroadcast(context, 0, intent, 0);
		locManager.addProximityAlert(loc.getLatitude(), loc.getLongitude(), 50, -1, pendingIntent);
	}

	public void removeProximityListener() {
		if (pendingIntent != null) {
			locManager.removeProximityAlert(pendingIntent);
		}
	}

	public void setBlockID(String ID) {
		this.blockID = ID;
	}

	@Override
	public void setBlockID(String blockID, String sessionID) {
		// TODO Auto-generated method stub
		
	}

}