package no.ntnu.item.arctis.library.android.location.reversegeocodetofulladdress;

import java.io.IOException;
import java.util.List;
import java.util.Locale;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;
import android.content.Context;
import android.location.Address;
import android.location.Geocoder;
import android.location.Location;
import android.util.Log;

public class ReverseGeocodeToFullAddress implements IArctisBuildingBlock {

	public Context context;
	private final String TAG = "ReverseGeocodeToFullAddress";

	private String blockID;
	private String sessionID;

	public void reverseGeocode(final Location loc) {
		Thread t = new Thread() {
			public void run() {
				context = (Context) AbstractRuntime.getRuntime(blockID).getContext("Android");
				if (loc != null) {
					Geocoder gc = new Geocoder(context, Locale.getDefault());
					try {
						Log.d(TAG, TAG + ":InverseGeocode, try" + loc.getLatitude() + loc.getLongitude());
						List<Address> addresses = gc.getFromLocation(loc.getLatitude(), loc.getLongitude(), 1);
						if (addresses.size() > 0) {
							Address address = addresses.get(0);
							AbstractRuntime.getRuntime(blockID).sendToBlock(sessionID,blockID, "ADDRESS" + "_" + blockID, address);
						} else {
							AbstractRuntime.getRuntime(blockID).sendToBlock(sessionID,blockID, "NO_ADDRESS" + "_" + blockID);
						}
					} catch (IOException e) {
						Log.d(TAG, TAG + "IOException");
						AbstractRuntime.getRuntime(blockID).sendToBlock(sessionID,blockID, "NO_ADDRESS" + "_" + blockID);
					}
				}
				// return null;
			}
		};
		t.start();
	}

	public String addressToString(Address address) {
		if (address != null) {
			Log.d(TAG, TAG + ": Locality set to " + address.toString());

			StringBuilder stringBuilder = new StringBuilder();
			int lines = address.getMaxAddressLineIndex();
			if (lines > 0) {
				stringBuilder.append(address.getAddressLine(0) + ", ");
			}

			String postalCode = address.getPostalCode();
			String cityName = address.getLocality();
			if (postalCode != null && cityName != null) {
				stringBuilder.append(postalCode + " ");
				stringBuilder.append(cityName);
			}
			return stringBuilder.toString();
		}
		return "No address found";
	}

	public void setBlockID(String ID) {
		this.blockID = ID;

	}

	@Override
	public void setBlockID(String blockID, String sessionID) {
		// TODO Auto-generated method stub
		
	}

}