package no.ntnu.item.arctis.library.android.activity;

import no.ntnu.item.arctis.library.android.alc.ArctisAndroidActivity;
import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Intent;

public class Activity extends AndroidBlock {

	public android.app.Activity activity;

	public void startActivity(int layoutResource) {
		// create an intent to start the provided Activity
		Intent intent = new Intent(getContext(), ArctisAndroidActivity.class);
		// add this block ID as extra, since the activity class uses it to send
		// signals
		intent.putExtra(ArctisAndroidActivity.BLOCK_ID_EXTRA_KEY, blockID);
		intent.putExtra(ArctisAndroidActivity.LAYOUT_ID_EXTRA_KEY, layoutResource);
		String wrapping = (String) AbstractRuntime.getRuntime(blockID).getContext("wrapping");
		if(wrapping!=null && wrapping.equalsIgnoreCase("service")) {
			intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		}
		
		// the activity with the intent
		getContext().startActivity(intent);
	}

	public void startActivityClass(Class myActivity) {
		// create an intent to start the provided Activity
		Intent intent = new Intent(getContext(), myActivity);
		// add this block ID as extra, since the activity class uses it to send
		// signals
		intent.putExtra(ArctisAndroidActivity.BLOCK_ID_EXTRA_KEY, blockID);
		String wrapping = (String) AbstractRuntime.getRuntime(blockID).getContext("wrapping");
		if(wrapping!=null && wrapping.equalsIgnoreCase("service")) {
			intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		}
		// the activity with the intent
		getContext().startActivity(intent);
	}

	public void finish() {
		activity.finish();
	}
}