package no.ntnu.item.arctis.library.android.alc4;

import no.ntnu.item.arctis.library.android.alc.ArctisAndroidActivity;
import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.Activity;
import android.content.Intent;

public class ALC4 extends AndroidBlock {

	public static final String BLOCK_ID_EXTRA_KEY = "BLOCK_ID";
	public android.app.Activity activity;

	public void startActivity(Class myActivity) {
		// create an intent to start the provided Activity
		final Intent intent = new Intent(getContext(), myActivity);
		// add this block ID as extra, since the activity class uses it to send
		// signals
		intent.putExtra(BLOCK_ID_EXTRA_KEY, blockID);
		intent.putExtra(ArctisAndroidActivity.SESSION_ID_EXTRA_KEY, sessionID);
		
		
		
		
		// the activity with the intent
		System.err.println(" +++++ starting intent to create activity of type " + myActivity.getSimpleName());
		System.err.println("       sessionID: " + sessionID);
		System.err.println("         blockID: " + blockID);

		
		
		
		if(getCurrentActivityContext() instanceof Activity) {
			System.err.println("       --> starting via activity context " + getCurrentActivityContext().getClass().getCanonicalName());
			final Activity parent = (Activity) getCurrentActivityContext();
			parent.runOnUiThread(new Runnable() {
				
				@Override
				public void run() {
					parent.startActivity(intent);
					System.err.println("       --> started from within runnable "); 
				}
			});
			
			
		} else {
			String wrapping = (String) AbstractRuntime.getRuntime().getContext("wrapping");
			if(wrapping!=null && wrapping.equalsIgnoreCase("service")) {
				intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);

			}
			System.err.println("       --> starting via service context ");
			getContext().startActivity(intent);
		}
		
	}

	public void finish() {
		System.err.println(" ----- finishing called a runnable" + activity.hashCode());
		Runnable r = new Runnable() {
			public void run() {
				activity.finish();
				System.err.println("    ----- finish called from within the runnable" + activity.hashCode());
			}
		};
		activity.runOnUiThread(r);
		
		
	}

	public Activity assertActivitySuperclass(Activity activity) {
		if(!(activity instanceof ArctisAndroidActivity)) {
			log("Activities handled by this block need to extend ArctisAndroidActivity");
		}
		return activity;
	}
	
	
	
}