package no.ntnu.item.arctis.library.android.alc5;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.Activity;
import android.os.Bundle;

public class ArctisAndroidActivity5 extends Activity {

	public static final String BLOCK_ID_EXTRA_KEY = "BLOCK_ID";
	public static final String LAYOUT_ID_EXTRA_KEY = "LAYOUT_ID";

	private String blockID;
	private String parentID;

	public void onCreate(Bundle savedInstanceState) {
		// setTheme(R.style.Theme_Dialog);
		super.onCreate(savedInstanceState);
		if (getIntent().hasExtra(LAYOUT_ID_EXTRA_KEY)) {
			int layoutID = getIntent().getIntExtra(LAYOUT_ID_EXTRA_KEY, 0);
			setContentView(layoutID);
		}
		blockID = getIntent().getStringExtra(BLOCK_ID_EXTRA_KEY);
		AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "onCreate_" + blockID, this);
	}

	public void setParentID(String id) {
		parentID = id;
	}

	public void onStart() {
		super.onStart();
		AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "onStart_" + blockID);
	}

	public void onResume() {
		super.onResume();
		AndroidBlock.setCurrentActivityContext(this, blockID);
		AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "onResume_" + blockID);
	}

	public void onRestart() {
		super.onRestart();
		AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "onRestart_" + blockID);
	}

	public void onPause() {
		super.onPause();
		AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "onPause_" + blockID);
	}

	public void onStop() {
		super.onStop();
		AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "onStop_" + blockID);
	}

	public void onDestroy() {
		super.onDestroy();
		AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "onDestroy_" + blockID);
		if (isFinishing()) {
			AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "ON_DESTROY_FINISHED_" + blockID);
		}
	}

	public void sendSignalToBuildingBlock(String signalName) {
		AbstractRuntime.getRuntime(parentID).sendToBlock(parentID, signalName + "_" + parentID);
	}

	public void sendSignalToBuildingBlockWithObject(String signalName, Object obj) {
		AbstractRuntime.getRuntime(parentID).sendToBlock(parentID, signalName + "_" + parentID, obj);
	}

}