package no.ntnu.item.arctis.library.android.broadcastreceiver;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;

public class BroadcastReceiver implements IArctisBuildingBlock {

	private String blockID;
	private Context context;
	private android.content.BroadcastReceiver br;

	public void removeRegistration() {
		context.unregisterReceiver(br);
	}

	public void initializeReceiver(String input) {
		context = (Context) AbstractRuntime.getRuntime(blockID).getContext("Android");
		br = new android.content.BroadcastReceiver() {
			public void onReceive(Context context, Intent intent) {
				AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "Intent_Arrived" + "_" + blockID, intent);
			}
		};
		context.registerReceiver(br, new IntentFilter(input));
	}

	public void setBlockID(String blockID) {
		this.blockID = blockID;
	}
}