package no.ntnu.item.arctis.library.android.consoleui;

import android.content.Context;
import android.text.Editable;
import android.text.method.MovementMethod;
import android.text.method.ScrollingMovementMethod;
import android.util.AttributeSet;
import android.widget.TextView;

public class ConsoleTextView extends TextView {
	public ConsoleTextView(Context context) {
		this(context, null);
	}

	public ConsoleTextView(Context context, AttributeSet attrs) {
		this(context, attrs, android.R.attr.textViewStyle);
	}

	public ConsoleTextView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
	}

	protected MovementMethod getDefaultMovementMethod() {
		return ScrollingMovementMethod.getInstance();
	}

	public Editable getText() {
		return (Editable) super.getText();
	}

	public void setText(CharSequence text, BufferType type) {
		super.setText(text, BufferType.EDITABLE);
	}
}
