package no.ntnu.item.arctis.library.android.consoleui;

import java.util.StringTokenizer;

import no.ntnu.item.arctis.android.R;
import no.ntnu.item.arctis.library.android.alc.ArctisAndroidActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.Window;

public class ConsoleUIActivity extends ArctisAndroidActivity {

	private ConsoleTextView view;
	public static final String CLEAR_ENTRY = "Clear";
	private String menuEntries;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_INDETERMINATE_PROGRESS);
		setContentView(R.layout.console_ui);
		this.view = (ConsoleTextView) findViewById(R.id.console_ui_text);
	}

	public void setEntries(String menuEntries) {
		this.menuEntries = menuEntries;
	}

	public void append(final String text, final boolean busy) {
		Runnable r = new Runnable() {
			public void run() {
				view.append(text + "\n");
				setProgressBarIndeterminateVisibility(busy);
			}
		};
		runOnUiThread(r);
	}

	public void clear() {
		Runnable r = new Runnable() {
			public void run() {
				view.setText("");
			}
		};
		runOnUiThread(r);
	}

	public boolean onCreateOptionsMenu(Menu menu) {
		boolean result = super.onCreateOptionsMenu(menu);
		StringTokenizer t = new StringTokenizer(menuEntries, ",");
		int i = 0;
		while (t.hasMoreTokens()) {
			menu.add(0, i++, 0, t.nextToken().trim());
		}
		menu.add(0, i++, 0, CLEAR_ENTRY);
		return result;
	}

	public boolean onOptionsItemSelected(MenuItem item) {
		if (item.getTitle().equals(CLEAR_ENTRY)) {
			view.setText("");
			return super.onOptionsItemSelected(item);
		} else {
			sendSignalToBuildingBlockWithObject("MENU", item.getTitle());
			return super.onOptionsItemSelected(item);
		}
	}

}