package no.ntnu.item.arctis.library.android.lightsensor;

import java.util.List;

import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorManager;
import android.hardware.SensorEventListener;
import no.ntnu.item.arctis.runtime.Block;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;

public class LightSensor extends AndroidBlock {

	public boolean registerListener() {
		SensorManager m = (SensorManager) getContext().getSystemService(Context.SENSOR_SERVICE);
		List<Sensor> sensors = m.getSensorList(Sensor.TYPE_LIGHT);
		if (sensors.size() > 0) {
			Sensor s = sensors.get(0);
			m.registerListener(new SensorEventListener() {
				public void onSensorChanged(SensorEvent event) {
					System.out.println("Sensor changed: " + event.values);
					// for (float f : event.values) {
					// System.out.println("   " + f);
					float light = event.values[0];
					sendToBlock("LIGHT_CHANGED" + "_" + blockID, light);
					if (light > SensorManager.LIGHT_SUNLIGHT_MAX) {
						System.out.println("SUNLIGHT MAX");
					} else if (light > SensorManager.LIGHT_SUNLIGHT) {
						System.out.println("SUNLIGHT");
					} else if (light > SensorManager.LIGHT_SHADE) {
						System.out.println("SHADE");
					} else if (light > SensorManager.LIGHT_OVERCAST) {
						System.out.println("OVERCAST");
					} else if (light > SensorManager.LIGHT_SUNRISE) {
						System.out.println("SUNRISE");
					} else if (light > SensorManager.LIGHT_CLOUDY) {
						System.out.println("CLOUDY");
					} else if (light > SensorManager.LIGHT_FULLMOON) {
						System.out.println("FULL MOON");
					} else if (light > SensorManager.LIGHT_NO_MOON) {
						System.out.println("NO MOON");
					}
				}

				public void onAccuracyChanged(Sensor sensor, int accuracy) {

				}
			}, s, SensorManager.SENSOR_DELAY_NORMAL);
			return true;
		}
		return false;
	}

}
