package no.ntnu.item.arctis.library.android.listen;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.speech.RecognizerIntent;

public class Listen extends AndroidBlock {

	public Intent createIntent() {
		return new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
	}
	
	public Set<String> extractResult(Intent result) {
		ArrayList<String> matches = result.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);
		Set<String> set = new HashSet<String>();
		for(String s: matches) {		            	
			set.add(s);
		}
		return set;
	}

	public boolean available() {
		// Check to see if a recognition activity is present
		PackageManager pm = getContext().getPackageManager();
		List<ResolveInfo> activities = pm.queryIntentActivities(new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH), 0);
		return activities.size()>0;
	}
}
