package no.ntnu.item.arctis.library.android.loginuicontrol;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;

public class LoginUIControl implements IArctisBuildingBlock {

	public no.ntnu.item.arctis.library.android.loginuicontrol.LoginUIControl.In in;

	private String blockID;

	public static interface In {
		public void ok();

		public void denied(String reason);

		public void setOut(Out out);
	}

	public static interface Out {
		public void cancel();

		public void login();
	}

	public void ok() {
		in.ok();
	}

	public void denied(String reason) {
		in.denied(reason);
	}

	public void init(In in) {
		this.in = in;
		in.setOut(new Out() {
			public void login() {
				AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "LOGIN" + "_" + blockID);
			}

			public void cancel() {
				AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "CANCEL" + "_" + blockID);
			}
		});
	}

	public void setBlockID(String blockID) {
		this.blockID = blockID;
	}
}