package no.ntnu.item.arctis.library.android.notification2;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;

public class Notification2 extends AndroidBlock {

	private static final String INTENT_EXTRA_SIGNAL_ID = "SIGNAL_ID";
	private static final String INTENT_EXTRA_BLOCK_ID = "BLOCK_ID";

	private static int notificationCount = 0;
	// Instance parameter. Edit only in overview page.
	public final boolean sound;
	// Instance parameter. Edit only in overview page.
	public final java.lang.String title;

	public void createNotification(final String text) {

		Runnable run = new Runnable() {
			public void run() {

				// lag intent
				Intent intent = new Intent(blockID);
				intent.putExtra(INTENT_EXTRA_SIGNAL_ID, "NOTIFICATION_PRESSED" + "_" + blockID);
				intent.putExtra(INTENT_EXTRA_BLOCK_ID, blockID);
				PendingIntent contentIntent = PendingIntent.getBroadcast(getContext(), 0, intent, 0);

				NotificationManager nm = (NotificationManager) getContext().getSystemService(Context.NOTIFICATION_SERVICE);
				Notification notification = new android.app.Notification(0x7f020001, title, System.currentTimeMillis());
				notification.setLatestEventInfo(getContext(), title, text, contentIntent);
				notification.flags |= android.app.Notification.FLAG_AUTO_CANCEL;
				if (sound) {
					notification.defaults |= android.app.Notification.DEFAULT_SOUND;
				}
				nm.notify(blockID.hashCode() + (notificationCount++), notification);
			}
		};
		getHandler().post(run);
	}

	// Do not edit this constructor.
	public Notification2(boolean sound, java.lang.String title) {
		this.sound = sound;
		this.title = title;
	}
}