package no.ntnu.item.arctis.library.android.onebuttondialog2;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import no.ntnu.item.arctis.runtime.android.InvisibleActivity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;

public class OneButtonDialog2 extends AndroidBlock {

	// Instance parameter. Edit only in overview page.
	public final java.lang.String buttonLabel;
	// Instance parameter. Edit only in overview page.
	public final java.lang.String text;


	public InvisibleActivity activityContext;

	public void displayDialog() {
		Runnable run = new Runnable() {
			public void run() {
				Builder builder = new AlertDialog.Builder(getContext());
				builder.setMessage(text);
				builder.setNeutralButton(buttonLabel, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface arg0, int arg1) {
						sendToBlock("OkReturn");
					}
				});
				builder.setOnCancelListener(new OnCancelListener() {
					public void onCancel(DialogInterface dialog) {
						sendToBlock("OkReturn");
					}
				});
				builder.show();
			}
		};
		getHandler().post(run);
	}
	
	public void showDialog2(final InvisibleActivity activityContext) {
		this.activityContext = activityContext;
		Runnable run = new Runnable() {
			public void run() {
				try {
					Builder builder = new AlertDialog.Builder(activityContext);
					builder.setMessage(text);
					builder.setNeutralButton(buttonLabel, new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface arg0, int arg1) {
							sendToBlock("OkReturn");
						}
					});
					builder.setOnCancelListener(new OnCancelListener() {
						public void onCancel(DialogInterface dialog) {
							sendToBlock("OkReturn");
						}
					});
					builder.show();
				} catch (Throwable e) {
					log("Error when opening the dialog.", e);
					sendToBlock("OkReturn");
				}
			}
		};
		getHandler().post(run);
	}

	// Do not edit this constructor.
	public OneButtonDialog2(java.lang.String buttonLabel, java.lang.String text) {
		this.buttonLabel = buttonLabel;
		this.text = text;
	}

	public void finishActivity() {
		if(activityContext!=null) {
			activityContext.finish();
		}
	}
}