package no.ntnu.item.arctis.library.android.onebuttondialog3;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;

public class OneButtonDialog3 extends AndroidBlock {

	// Parameter defined by UML. Do not edit.
	public final java.lang.String buttonLabel;

	// Do not edit this constructor.
	public OneButtonDialog3(java.lang.String buttonLabel) {
		this.buttonLabel = buttonLabel;
	}

	public void displayDialog(final String text) {
		final Context context = getCurrentActivityContext();
		Runnable run = new Runnable() {
			public void run() {
				Builder builder = new AlertDialog.Builder(context);
				builder.setMessage(text);
				builder.setNeutralButton(buttonLabel, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface arg0, int arg1) {
						sendToBlock("OkReturn");
					}
				});
				builder.setOnCancelListener(new OnCancelListener() {
					
					@Override
					public void onCancel(DialogInterface dialog) {
						sendToBlock("OkReturn");
					}
				});
				builder.show();
			}
		};
		getHandler().post(run);
	}
}