package no.ntnu.item.arctis.library.android.optionsdialog;

import java.util.StringTokenizer;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;

public class OptionsDialog extends AndroidBlock {

	// Instance parameter. Edit only in overview page.
	public final java.lang.String title;
	// Instance parameter. Edit only in overview page.
	public final java.lang.String choices;

	public void displayDialog(final Activity context) {
		Runnable run = new Runnable() {
			public void run() {
				AlertDialog.Builder ab=new AlertDialog.Builder(context);
				ab.setTitle(title);
				ab.setItems(parse(choices), new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface d, int choice) {
						sendToBlock("CHOICE", choice);
					}
				});
				ab.show();
			}
		};
		getHandler().post(run);
	}

	// Do not edit this constructor.
	public OptionsDialog(java.lang.String title, java.lang.String choices) {
	    this.title = title;
	    this.choices = choices;
	}
	
	private static String[] parse(String string) {
		StringTokenizer t = new StringTokenizer(string, ",");
		String[] choices = new String[t.countTokens()];
		int i = 0;
		while (t.hasMoreTokens()) {
			choices[i] = t.nextToken().trim();
		}
		return choices;
	}
}