package no.ntnu.item.arctis.library.android.phonecalls;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Context;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;

public class PhoneCalls extends AndroidBlock {

	private TelephonyManager t;
	private PhoneStateListener l;

	public void listen() {
		t = (TelephonyManager) getContext().getSystemService(Context.TELEPHONY_SERVICE);
		Runnable r = new Runnable() {
			public void run() {
				l = new PhoneStateListener() {
					public void onCallStateChanged(int state, String incomingNumber) {
						if (state == TelephonyManager.CALL_STATE_RINGING) {
							log("Incoming number: " + incomingNumber);
							sendToBlock("RINGING" + "_" + blockID, incomingNumber);
						} else if (state == TelephonyManager.CALL_STATE_OFFHOOK) {
							log("Incoming number: " + incomingNumber);
							sendToBlock("OFFHOOK" + "_" + blockID, incomingNumber);
						} else if (state == TelephonyManager.CALL_STATE_IDLE) {
							log("Incoming number: " + incomingNumber);
							sendToBlock("IDLE" + "_" + blockID);
						}
					}
				};
				t.listen(l, PhoneStateListener.LISTEN_CALL_STATE);
			}
		};
		getHandler().post(r);
	}

	public void stop() {
		t.listen(l, PhoneStateListener.LISTEN_NONE);
	}
}