package no.ntnu.item.arctis.library.android.preferences;

import no.ntnu.item.arctis.android.R;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.EditTextPreference;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;

public class ArctisPreferenceActivity extends PreferenceActivity {

	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		addPreferencesFromResource(R.xml.preferences);
		SharedPreferences shared = PreferenceManager.getDefaultSharedPreferences(getApplication());
		for (String s : shared.getAll().keySet()) {
			Preference p = findPreference(s);
			if (p instanceof EditTextPreference) {
				treatEditTextPreference((EditTextPreference) p);
			}
			// not sure if other preferences need some behavior
		}
	}

	/**
	 * Add a default behavior to edit text preferences so that they show the
	 * current text as a summary, also after they have been changed.
	 * 
	 * @param p
	 */
	private void treatEditTextPreference(EditTextPreference p) {
		SharedPreferences shared = PreferenceManager.getDefaultSharedPreferences(getApplication());
		p.setSummary(shared.getString(p.getKey(), "default"));
		p.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
			public boolean onPreferenceChange(Preference preference, Object newValue) {
				preference.setSummary((String) newValue);
				return true;
			}
		});
	}
}
