package no.ntnu.item.arctis.library.android.progressdialog2;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;

public class ProgressDialog2 extends AndroidBlock {

	private ProgressDialog dialog;
	// Instance parameter. Edit only in overview page.
	public final java.lang.String message;
	// Instance parameter. Edit only in overview page.
	public final java.lang.String label;
	public void showDialog2(final Activity activityContext) {

		final OnCancelListener cancelListener = new OnCancelListener() {
			public void onCancel(DialogInterface arg0) {
				sendToBlock("CANCELED" + "_" + blockID);
			}
		};

		Runnable r = new Runnable() {
			public void run() {
				boolean indeterminate = true;
				boolean cancelable = true;
				dialog = ProgressDialog.show(activityContext, label, message, indeterminate, cancelable, cancelListener);
				sendToBlock("CREATED");
			}
		};
		activityContext.runOnUiThread(r);
	}

	public void showDialog() {
		final Context context = getCurrentActivityContext() != null ? getCurrentActivityContext() : getContext();
		final OnCancelListener cancelListener = new OnCancelListener() {
			public void onCancel(DialogInterface arg0) {
				sendToBlock("CANCELED" + "_" + blockID);
			}
		};

		Runnable r = new Runnable() {
			public void run() {
				boolean indeterminate = true;
				boolean cancelable = true;
				dialog = ProgressDialog.show(context, label, message, indeterminate, cancelable, cancelListener);
				sendToBlock("CREATED");
			}
		};
		getHandler().post(r);
	}

	public void hideDialog() {
		if(dialog!=null) {
			dialog.setOnCancelListener(null);
			dialog.setOnDismissListener(null);
			dialog.cancel();
		}
	}

	// Do not edit this constructor.
	public ProgressDialog2(java.lang.String message, java.lang.String label) {
	    this.message = message;
	    this.label = label;
	}
}