package no.ntnu.item.arctis.library.android.progressdialog3;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import no.ntnu.item.arctis.runtime.android.InvisibleActivity;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;

public class ProgressDialog3 extends AndroidBlock {


	private ProgressDialog dialog;
	private InvisibleActivity activityContext;

	// Instance parameter. Edit only in overview page.
	public final java.lang.String message;
	// Instance parameter. Edit only in overview page.
	public final java.lang.String label;
	// Instance parameter. Edit only in overview page.
	public final int maxProgress;
	
	public void showDialog2(final InvisibleActivity activityContext) {
		this.activityContext = activityContext;
		final OnCancelListener cancelListener = new OnCancelListener() {
			public void onCancel(DialogInterface arg0) {
				sendToBlock("CANCELED" + "_" + blockID);
			}
		};

		Runnable r = new Runnable() {
			public void run() {
				boolean cancelable = true;
				boolean indeterminate = false;
				dialog = new ProgressDialog(activityContext);
				dialog.setTitle(label);
				dialog.setMessage(message);
				dialog.setIndeterminate(indeterminate);
				dialog.setCancelable(cancelable);
				dialog.setOnCancelListener(cancelListener);
				dialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
				dialog.setMax(maxProgress);
				dialog.setProgress(0);
				dialog.show();
			}
		};
		activityContext.runOnUiThread(r);
	}

//	public void showDialog() {
//		final Context context = getContext();
//		final OnCancelListener cancelListener = new OnCancelListener() {
//			public void onCancel(DialogInterface arg0) {
//				sendToBlock("CANCELED" + "_" + blockID);
//			}
//		};
//
//		Runnable r = new Runnable() {
//			public void run() {
//				boolean indeterminate = true;
//				boolean cancelable = true;
//				dialog = ProgressDialog.show(context, label, message, indeterminate, cancelable, cancelListener);
//			}
//		};
//		getHandler().post(r);
//	}

	public void hideDialog() {
		dialog.setOnCancelListener(null);
		dialog.setOnDismissListener(null);
		dialog.cancel();
		if(activityContext!=null) {
			activityContext.finish();
		}
	}
	
//	public void setMessage(final String message) {
//		Runnable r = new Runnable() {
//			
//			@Override
//			public void run() {
//				dialog.setMessage(message);
//			}
//		};
//		activityContext.runOnUiThread(r);
//	}

	public void setProgress(final int total) {
		Runnable r = new Runnable() {
			
			@Override
			public void run() {
				dialog.setProgress(total);
				if(total >= maxProgress)
					sendToBlock("FINISHED");
			}
		};
		activityContext.runOnUiThread(r);
	}

	// Do not edit this constructor.
	public ProgressDialog3(java.lang.String message, java.lang.String label, int maxProgress) {
	    this.message = message;
	    this.label = label;
	    this.maxProgress = maxProgress;
	}
}