package no.ntnu.item.arctis.library.android.receivesms;

import no.ntnu.item.arctis.library.objects.telephony.SMS;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.TelephonyManager;
import android.telephony.gsm.SmsMessage;

public class ReceiveSMS extends AndroidBlock {

	public String getReceiveSMSIntent() {
		return "android.provider.Telephony.SMS_RECEIVED";
	}

	public SMS extractSMS(Intent intent) {
		Bundle bundle = intent.getExtras();
		SmsMessage[] msgs = null;
		String str = "";
		if (bundle != null) {
			// ---retrieve the SMS message received---
			Object[] pdus = (Object[]) bundle.get("pdus");
			msgs = new SmsMessage[pdus.length];
			for (int i = 0; i < msgs.length; i++) {
				msgs[i] = SmsMessage.createFromPdu((byte[]) pdus[i]);
				str += "SMS from " + msgs[i].getOriginatingAddress();
				str += " :";
				str += msgs[i].getMessageBody().toString();
				str += "\n";
			}
			if (msgs.length > 0) {
				TelephonyManager m = (TelephonyManager) getContext().getSystemService(Context.TELEPHONY_SERVICE);
				String receiver = m.getLine1Number();

				String body = msgs[0].getMessageBody();
				if (body == null || body.trim().length() == 0) {
					body = "";
				}

				SMS sms = new SMS(body, msgs[0].getOriginatingAddress(), receiver);
				return sms;
			} else {
				return null;
			}
		} else {
			return null;
		}
	}

}