package no.ntnu.item.arctis.library.android.scanbarcode;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import no.ntnu.item.arctis.runtime.android.IActivityResultListener;
import no.ntnu.item.arctis.runtime.android.InvisibleActivity;
import android.app.Activity;
import android.content.Intent;

public class ScanBarcode extends AndroidBlock {

	public Intent createScanIntent() {
		return new Intent("com.google.zxing.client.android.SCAN");
	}

	public void startActivity() {
		Intent intent = new Intent(getContext(), InvisibleActivity.class);
		// add this block ID as extra, since the activity class uses it to send
		// signals
		intent.putExtra(InvisibleActivity.BLOCK_ID_EXTRA_KEY, blockID);
		// the activity with the intent
		getContext().startActivity(intent);
	}
	
	public String extractCode(Intent result) {
		String code = result.getStringExtra("SCAN_RESULT");
		if(code==null) {
			return null;
		} else if(code.equals("RESULT_CANCELED")) {
			return null;
		} else {
			return code;
		}
	}


	public void startIntent(InvisibleActivity activity) {
		Intent intent = new Intent("com.google.zxing.client.android.SCAN");
		activity.registerOnActivityResultListener(0, new IActivityResultListener() {
			public void onActivityResult(int resultCode, Intent data) {
				if (resultCode == Activity.RESULT_OK) {
					System.out.println("RESULT:");		            
		            String result = data.getStringExtra("SCAN_RESULT");
		            if(result.equals("RESULT_CANCELED")) {
		            	sendToBlock("CANCEL");
		            } else {
		            	sendToBlock("RESULT", result);
		            }
		        } else {
		        	sendToBlock("ERROR");
		        }				
			}
		});
		activity.startActivityForResult(intent, 0);
	}

	public void dummy(String s) {
		// only added to force downstream pattern to require data type
	}
}