package no.ntnu.item.arctis.library.android.smssend;

import no.ntnu.item.arctis.library.objects.telephony.SMS;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.Activity;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.telephony.gsm.SmsManager;

public class SMSSend extends AndroidBlock {

	private BroadcastReceiver b1, b2;

	public void sendSMS(SMS sms) {
		String action1 = blockID + "SEND";
		PendingIntent p1 = PendingIntent.getBroadcast(getContext(), 0, new Intent(action1), PendingIntent.FLAG_ONE_SHOT);
		b1 = new BroadcastReceiver() {
			public void onReceive(Context arg0, Intent i) {
				if (b1.getResultCode() == Activity.RESULT_OK) {
					System.out.println("SEND SMS: OK");
				} else {
					switch (getResultCode()) {
					case SmsManager.RESULT_ERROR_GENERIC_FAILURE:
						System.out.println("SEND SMS: GENERIC FAILURE");
						break;
					case SmsManager.RESULT_ERROR_RADIO_OFF:
						System.out.println("SEND SMS: REDIO OFF");
						break;
					case SmsManager.RESULT_ERROR_NULL_PDU:
						System.out.println("SEND SMS: NULL PDU");
						break;
					case SmsManager.RESULT_ERROR_NO_SERVICE:
						System.out.println("SEND SMS: NO SERVICE");
						break;
					}
					sendToBlock("DELIVER_FAILED" + "_" + blockID);
				}
			}
		};
		getContext().registerReceiver(b1, new IntentFilter(action1));

		String action2 = blockID + "DELIVER";
		PendingIntent p2 = PendingIntent.getBroadcast(getContext(), 0, new Intent(action2), PendingIntent.FLAG_ONE_SHOT);
		b2 = new BroadcastReceiver() {
			public void onReceive(Context arg0, Intent i) {
				// byte[] pdu = i.getExtras().getByteArray("pdu");
				// System.out.println("PDU: " + new String(pdu));
				if (getResultCode() == Activity.RESULT_OK) {
					sendToBlock("DELIVER_OK" + "_" + blockID);
				} else {
					sendToBlock("DELIVER_FALIED" + "_" + blockID);
				}
			}
		};
		getContext().registerReceiver(b2, new IntentFilter(action2));

		SmsManager.getDefault().sendTextMessage(sms.receiver, sms.sender, sms.message, p1, p2);
	}

	public void removeReceivers() {
		// Context context = (Context)
		// AbstractRuntime.getRuntime(blockID).getContext("Android");
		// context.removeStickyBroadcast(arg0)
	}

}