package no.ntnu.item.arctis.library.android.speech;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Context;
import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnInitListener;
import android.speech.tts.TextToSpeech.OnUtteranceCompletedListener;

public class Speech extends AndroidBlock {

	public TextToSpeech textToSpeach;
	public java.lang.String text;

	public void initialize() {
		Context context = (Context) getContext();
		textToSpeach = new TextToSpeech(context, new OnInitListener() {
			public void onInit(int status) {
				if (status == TextToSpeech.SUCCESS) {
					sendToBlock("READY");
				} else {
					sendToBlock("INIT_FAILED");
				}
			}
		});
		textToSpeach.setOnUtteranceCompletedListener(new OnUtteranceCompletedListener() {
			public void onUtteranceCompleted(String arg0) {
				sendToBlock("DONE");
			}
		});
	}

	public void speak() {
		textToSpeach.speak(text, TextToSpeech.QUEUE_FLUSH, null);
	}

}