package no.ntnu.item.arctis.library.android.speech1;

import java.util.HashMap;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnUtteranceCompletedListener;

public class Speech1 extends AndroidBlock {

	public TextToSpeech engine;

	public Speech1() {
	}

	public void initialize() {
		engine = new TextToSpeech(getContext(), new TextToSpeech.OnInitListener() {
			public void onInit(int status) {
				if (status == TextToSpeech.SUCCESS) {
					sendToBlock("SPEECH_INIT_OK" + "_" + blockID);
				} else {
					sendToBlock("SPEECH_INIT_FAILED" + "_" + blockID);
				}
			}
		});
	}

	public void release() {
		engine.shutdown();
	}

	public void speak(String text) {
		final String ID = blockID;
		HashMap<String, String> params = new HashMap<String, String>();
		params.put(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID, ID);
		engine.setOnUtteranceCompletedListener(new OnUtteranceCompletedListener() {
			public void onUtteranceCompleted(String utteranceId) {
				if (ID.equals(utteranceId)) {
					sendToBlock("SPEECH_COMPLETED");
				}
			}
		});
		engine.speak(text, TextToSpeech.QUEUE_ADD, params);
	}
}
