package no.ntnu.item.arctis.library.android.startintentforresult;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import no.ntnu.item.arctis.runtime.android.IActivityResultListener;
import no.ntnu.item.arctis.runtime.android.InvisibleActivity;
import android.app.Activity;
import android.content.ActivityNotFoundException;
import android.content.Intent;

public class StartIntentforResult extends AndroidBlock {

	public android.content.Intent intent;
	private boolean wasNotFound = false;

	public void startActivity() {
		Intent intent = new Intent(getContext(), InvisibleActivity.class);
		intent.putExtra(InvisibleActivity.BLOCK_ID_EXTRA_KEY, blockID);
		intent.putExtra(InvisibleActivity.SESSION_ID_EXTRA_KEY, sessionID);
		String wrapping = (String) AbstractRuntime.getRuntime(blockID).getContext("wrapping");
		if(wrapping!=null && wrapping.equalsIgnoreCase("service")) {
			intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		}
		getContext().startActivity(intent);
	}

	public void startIntent(InvisibleActivity activity) {
		activity.registerOnActivityResultListener(0, new IActivityResultListener() {
			public void onActivityResult(int resultCode, Intent data) {
				if (resultCode == Activity.RESULT_OK) {
	            	sendToBlock("RESULT", data);
		        } else {
		        	if(!wasNotFound) {
		        		sendToBlock("CANCEL");
		        	}
		        }				
			}
		});
		try {
			activity.startActivityForResult(intent, 0);
		} catch (ActivityNotFoundException e) {
			wasNotFound = true;
			sendToBlock("NOT_FOUND");
		}
	}

}
