package no.ntnu.item.arctis.library.android.stringinputdialog;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.widget.EditText;

public class StringInputDialog extends AndroidBlock {

	// Parameter defined by UML. Do not edit.
	public final java.lang.String title;
	// Parameter defined by UML. Do not edit.
	public final java.lang.String description;
	// Parameter defined by UML. Do not edit.
	public final java.lang.String initialText;

	public void showDialog() {
		Runnable r = new Runnable() {
			public void run() {
				AlertDialog.Builder alert = new AlertDialog.Builder(getCurrentActivityContext());
				alert.setTitle(title);
				alert.setMessage(description);

				final EditText input = new EditText(getContext());
				input.setText(initialText);
				input.selectAll();
				alert.setView(input);

				alert.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int whichButton) {
						String value = input.getText().toString();
						sendToBlock("OK" + "_" + blockID, value);
					}
				});

				alert.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int whichButton) {
						sendToBlock("CANCELED" + "_" + blockID);
					}
				});
				alert.show();
			}
		};
		getHandler().post(r);
	}

	// Do not edit this constructor.
	public StringInputDialog(java.lang.String title, java.lang.String description, java.lang.String initialText) {
		this.title = title;
		this.description = description;
		this.initialText = initialText;
	}
}