package no.ntnu.item.arctis.library.android.threebuttondialog;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;

public class ThreeButtonDialog extends AndroidBlock {

	// Parameter defined by UML. Do not edit.
	public final java.lang.String positiveLabel;
	// Parameter defined by UML. Do not edit.
	public final java.lang.String neutralLabel;
	// Parameter defined by UML. Do not edit.
	public final java.lang.String negativeButton;

	public void displayDialog(final String text) {
		Runnable run = new Runnable() {
			public void run() {
				Builder builder = new AlertDialog.Builder(getContext());
				builder.setMessage(text);
				builder.setPositiveButton(positiveLabel, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface arg0, int arg1) {
						sendToBlock("PositiveReply");
					}
				});
				builder.setNeutralButton(neutralLabel, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface arg0, int arg1) {
						sendToBlock("NeutralReply");
					}
				});
				builder.setNegativeButton(negativeButton, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface arg0, int arg1) {
						sendToBlock("NegativeReply");
					}
				});
				builder.show();
			}
		};
		getHandler().post(run);
	}

	// Do not edit this constructor.
	public ThreeButtonDialog(java.lang.String positiveLabel, java.lang.String neutralLabel, java.lang.String negativeButton) {
		this.positiveLabel = positiveLabel;
		this.neutralLabel = neutralLabel;
		this.negativeButton = negativeButton;
	}
}
