package no.ntnu.item.arctis.library.android.timeinputdialog;

import java.sql.Time;
import java.util.Date;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.TimePickerDialog;
import android.app.TimePickerDialog.OnTimeSetListener;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;
import android.widget.TimePicker;

public class TimeInputDialog extends AndroidBlock {

	private TimePickerDialog dialog;

	public void showDialog() {
		final OnTimeSetListener timeListener = new OnTimeSetListener() {
			public void onTimeSet(TimePicker picker, int arg1, int arg2) {
				sendToBlock("TIME_SET" + "_" + blockID, new Time(arg1, arg2, 0));
			}
		};

		final OnCancelListener ocl = new OnCancelListener() {
			public void onCancel(DialogInterface arg0) {
				sendToBlock("CANCELED" + "_" + blockID);
			}
		};

		Runnable r = new Runnable() {
			public void run() {
				Date d = new Date();
				dialog = new TimePickerDialog(getContext(), timeListener, d.getHours(), d.getMinutes(), true);
				dialog.setOnCancelListener(ocl);
				dialog.setCancelable(true);
				dialog.show();
			}
		};
		getHandler().post(r);
	}

}