package no.ntnu.item.arctis.library.android.twobuttondialog;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;

public class TwoButtonDialog extends AndroidBlock {

	// Parameter defined by UML. Do not edit.
	public final java.lang.String yesLabel;
	// Parameter defined by UML. Do not edit.
	public final java.lang.String noLabel;

	public void displayDialog(final String text) {
		Runnable run = new Runnable() {
			public void run() {
				Builder builder = new AlertDialog.Builder(getContext());
				builder.setMessage(text);
				builder.setPositiveButton(yesLabel, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface arg0, int arg1) {
						sendToBlock("YES" + "_" + blockID);
					}
				});
				builder.setNegativeButton(noLabel, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface arg0, int arg1) {
						sendToBlock("NO" + "_" + blockID);
					}
				});
				builder.show();
			}
		};
		getHandler().post(run);
	}

	// Do not edit this constructor.
	public TwoButtonDialog(java.lang.String yesLabel, java.lang.String noLabel) {
		this.yesLabel = yesLabel;
		this.noLabel = noLabel;
	}
}