package no.ntnu.item.arctis.library.proxies.actorrouter;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import no.tellu.common.javaframe.messages.AFClassLoader;
import no.tellu.common.javaframe.messages.ActorMsg;
import no.tellu.common.javaframe.messages.StringHelper;

public class ActorMessage extends ActorMsg {
	
    public java.lang.String message;

	
	public ActorMessage () {    
	}
	
	public ActorMessage(java.lang.String message){
		this.message = message;
	}

	@Override
	public String messageContent() {
		return super.messageContent() ;
	}

	/**
	 * This function implements the serialization of the object.
	 *
	 * @return a byte array with the objects data
	 * @throws java.io.IOException
	 */
	@Override
	public byte[] serialize() throws IOException {
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		DataOutputStream dout = new DataOutputStream(bout);
		dout.write(super.serialize());

		dout.write(StringHelper.persist(message));
		
		dout.flush();
		return bout.toByteArray();
	}

	/**
	 * Use this function for resurrection of the object
	 *
	 * @param data The serialized data containing the object data
	 * @throws java.io.IOException
	 */
	@Override
	public ByteArrayInputStream deSerialize(byte[] data) throws IOException {
		ByteArrayInputStream bin = super.deSerialize(data);
		DataInputStream din = new DataInputStream(bin);
		
		message = StringHelper.resurrect(din);

		return bin;
	} 


	/**
	 * Use this function for resurrection of the object
	 *
	 * @param data The serialized data containing the object data
	 * @throws java.io.IOException
	 */
	@Override
	public ByteArrayInputStream deSerialize(byte[] data, AFClassLoader cl) throws IOException {
		ByteArrayInputStream bin = super.deSerialize(data, cl);
		DataInputStream din = new DataInputStream(bin);

	    message = StringHelper.resurrect(din);
		
		return bin;
	}           
}
