package no.ntnu.item.arctis.library.proxies.actorrouter;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

import android.content.Intent;

import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.library.proxies.actorrouter.android.ActorframeContainer;
import no.ntnu.item.arctis.runtime.Block;
import no.tellu.common.application.Application;
import no.tellu.common.javaframe.ActorAddress;
import no.tellu.common.javaframe.ActorSpec;
import no.tellu.common.javaframe.ApplicationSpec;
import no.tellu.common.javaframe.PartSpec;
import no.tellu.common.services.actorrouter.SessionManagerSpec;
import no.tellu.j2se.actorframe.ActorSpecParser;
import no.tellu.j2se.application.J2SEContainer;

public class ActorRouter extends Block {

	public no.ntnu.item.arctis.library.proxies.Message message;
	private Application application;
	private ApplicationSpec applicationSpec;
	public static ActorRouter actorRouterInstance;
	
	private boolean isAndroidApp = false;
	
	// hash map for sessionId to router mapping
	private static Map<String,ActorAddress> sessionId2RouterMapping = new HashMap<String, ActorAddress>();
	
	public void startAfRouter(String type) {
				
		assert type!=null;
		
		actorRouterInstance = this;
	
		try{
			application = new Application();
			
			if(type.split("-")[0].equalsIgnoreCase("server")){
				applicationSpec = ActorSpecParser.parseXml("bin/no/ntnu/item/arctis/library/proxies/actorrouter/ServerRouterApplicationSpec.xml");
				
				SessionManagerSpec sessionManagerSpec = applicationSpec.getSessionManagerSpec("tcpSession");
				applicationSpec.addSessionManagerSpec(sessionManagerSpec);
								
				String stype = sessionManagerSpec.getType();
				String id = sessionManagerSpec.getId();
				String className = sessionManagerSpec.getClassName();
				String gatewayIP = type.split("-")[1]; //sessionManagerSpec.getGatewayIP();
				int gatewayPort = sessionManagerSpec.getGatewayPort();
				int listnerPort = Integer.valueOf(type.split("-")[2]); //sessionManagerSpec.getListnerPort();
				sessionManagerSpec = new SessionManagerSpec(stype, id, className, gatewayIP, gatewayPort, listnerPort);
				
				// uncomment the line below for parameters from model
				applicationSpec.addSessionManagerSpec(sessionManagerSpec);	
			}
			else if(type.split("-")[0].equalsIgnoreCase("AndroidClient")){
				isAndroidApp = true;			
			}
			else{
				applicationSpec = ActorSpecParser.parseXml("bin/no/ntnu/item/arctis/library/proxies/actorrouter/ClientRouterApplicationSpec.xml");
							
				System.out.println(applicationSpec);
				
				ActorSpec actorSpec = applicationSpec.getActorSpec("ActorDomain");				
				applicationSpec.removeActorSpec("ActorDomain");

				PartSpec part = actorSpec.getPartSpec("Router");
				actorSpec.deletePartSpec("Router");
				
				String [] rnames = part.getRoleNames();
				
				String str_date= now();
				str_date = str_date.replaceAll(" ", "");
			
				rnames[0] = str_date + rnames[0];
				part.setRoleNames(rnames);
				
				actorSpec.addPartSpec(part);
				
				applicationSpec.addActorSpec(actorSpec);	
				
				System.out.println("applicationSpec");
				System.out.println(applicationSpec);
				
				SessionManagerSpec sessionManagerSpec = applicationSpec.getSessionManagerSpec("GatewayTCPSession");
				applicationSpec.addSessionManagerSpec(sessionManagerSpec);
				
				String stype = sessionManagerSpec.getType();
				String id = sessionManagerSpec.getId();
				String className = sessionManagerSpec.getClassName();
				String gatewayIP = type.split("-")[1]; //sessionManagerSpec.getGatewayIP();
				int gatewayPort = Integer.valueOf(type.split("-")[2]); //sessionManagerSpec.getGatewayPort();
				int listnerPort = Integer.valueOf(type.split("-")[3]); //sessionManagerSpec.getListnerPort();
				sessionManagerSpec = new SessionManagerSpec(stype, id, className, gatewayIP, gatewayPort, listnerPort);
				
				// uncomment the line below for parameters from model
				 applicationSpec.addSessionManagerSpec(sessionManagerSpec);				
			}
			
			application.setApplicationSpec(applicationSpec);

			if(!isAndroidApp){
				J2SEContainer container = new J2SEContainer(application);		        
				container.init();
				container.start();
		    }
		    else{
		    	System.out.println("Starting ActorRouter in Android....");
		    	
		    	Intent intent = new android.content.Intent((android.content.Context)getProperty("androidContext"), ActorframeContainer.class);
		    	
		    	String serveripFromDialog= (String)getProperty("server-ip-address");
		    
		    	if(serveripFromDialog!=null & serveripFromDialog!=""){
		    		intent.putExtra("gatewayIP", serveripFromDialog);
		    	}
		    	else{
		    		intent.putExtra("gatewayIP", type.split("-")[1]);
		    	}
		    	
		    	intent.putExtra("gatewayPort", type.split("-")[2]);
		    	intent.putExtra("listnerPort", type.split("-")[3]);
		    	
		    	((android.content.Context)getProperty("androidContext")).startService(intent);
		    	
		    }
		}
		catch (Exception ex){
			System.err.println("Actor Router can not be started");
		}
	}
	
	public String now() {
	    java.util.Calendar cal = java.util.Calendar.getInstance();
	    java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat("yyyyMMddhhmmssSSS");
	    return sdf.format(cal.getTime());
	}
	
	/**
	 * this method is just to test the stand-alone ActorRouter.java file 
	 * @param args
	 */
	public static void main(String[] args){
		new ActorRouter().startAfRouter("Server-129.241.220.187-4439");
	}
	
	
	private static ActorAddress getActorRouterAddress(String key){
		ActorAddress addr = null;
		
		Iterator<Entry<String, ActorAddress>> itr1 = sessionId2RouterMapping.entrySet().iterator();	
      	while(itr1.hasNext()){	      		
      		Map.Entry<String, ActorAddress> me = itr1.next(); 
      		if(me.getKey().toString().equalsIgnoreCase(key)){
      			addr = me.getValue();
      			return addr;
      		}
      	}
		//System.out.println("getActorRouterAddress return key: " + addr);    			
		return addr;
	}

	/**
	 * this method is used to send the message from this ActorRouter to another ActorRouter
	 * over the network
	 * @param message
	 */
	public void send2network(Message message) {		
		
		System.out.println("@ActorRouter send2network message: "+ message.toString());
		
		//if Register or Deregister or Discover message, send message to serverRouter
		if(message.getSignalID().equalsIgnoreCase("register") | message.getSignalID().equalsIgnoreCase("discover")){	
			RouterSM.getInstance().sendMessage(messageToActorMessage(message), new ActorAddress("/serverRouter","Router"));
		}
		// sending OK message as ACK to register or discover 
		else if(message.getSignalID().equalsIgnoreCase("ok")){
			
			//RouterSM.getInstance().sendMessage(messageToActorMessage(message), sessionId2RouterMapping.get(message.getReceiver().toString()));	
			
			ActorAddress router = getActorRouterAddress(message.getReceiver().toString());
			if(router != null){
				RouterSM.getInstance().sendMessage(messageToActorMessage(message), router);
			}else{
				System.out.println("Could not find proper ActorRouter Address..");
			}
		}
		// all service specific messages are routed via serverActorRouter
		else{		
			RouterSM.getInstance().sendMessage(messageToForwardActorMessage(message), new ActorAddress("/serverRouter","Router"));
		}
	}

	// do not change as well, this method receives remote messages from RouterCS state machine
    public static final void receive(ActorMessage actorMessage){    	    	
    	Message msg = actorMessageToMessage(actorMessage);  
  
     	System.out.println("@ActorRouter receives ActorMessage, message ID: "+
     			msg.getSignalID()+ "sender....." + msg.getSender()+
     			"receiver....." + msg.getReceiver()+ "payload....." + msg.getPayload()); 	
		
    	if(msg.getSignalID().equalsIgnoreCase("register")) {
    		//System.out.println("register message");
    		sessionId2RouterMapping.put(msg.getPayload().toString().split("-")[1], actorMessage.getSenderRole()); 		
    	}   	
    	else if(msg.getSignalID().equalsIgnoreCase("discover")) {
    		//System.out.println("discover message");
    		//sessionId2RouterMapping.put(msg.getPayload().toString().split("-")[1], actorMessage.getSenderRole()); 		
    	}
       	
       	if(actorMessageToMessage(actorMessage).getSender().toString() !=null)
    	sessionId2RouterMapping.put(actorMessageToMessage(actorMessage).getSender().toString(), actorMessage.getSenderRole());
        
       	//printing
       	printSessionId2RouterMapping();
        
       	assert actorRouterInstance!=null;
    	actorRouterInstance.sendToBlock("AFMSG", actorMessageToMessage(actorMessage));
    
    }
    
    private static void printSessionId2RouterMapping(){
        // printing existing map
       	System.out.println("Printing sessionId2RouterMapping at ActorRouter..");
        Iterator itt = sessionId2RouterMapping.entrySet().iterator();
        while(itt.hasNext()){
        	Map.Entry<String, ActorAddress> entry = (Map.Entry<String, ActorAddress>) itt.next();
        	System.out.println("key value: " + entry.getKey() +" " + entry.getValue());
        }
    }
    
    public static final void forward(ForwardActorMessage actorMessage){
    	
    	System.out.println("@ActorRouter receives forward ForwardActorMessage: "+ actorMessage.message);

      	// update the sessionId2RouterMapping table sender of message to sender actor router 
    	sessionId2RouterMapping.put(actorMessageToMessage(new ActorMessage(actorMessage.message)).getSender().toString(), actorMessage.getSenderRole());    	
   	
    	//printing 
       	printSessionId2RouterMapping();
    	
   		String receiverAddrStr = actorMessage.message.split(";")[2];
		String receiverAddrStrSessionId = receiverAddrStr.split("-")[0];
    	
		if (getActorRouterAddress(receiverAddrStrSessionId) != null){
			RouterSM.getInstance().sendMessage(new ActorMessage(actorMessage.message),getActorRouterAddress(receiverAddrStrSessionId));
			System.out.println("forwarded to "+ getActorRouterAddress(receiverAddrStrSessionId));
		}else if(getActorRouterAddress(receiverAddrStr) != null){
   			RouterSM.getInstance().sendMessage(new ActorMessage(actorMessage.message),getActorRouterAddress(receiverAddrStr));
			System.out.println("forwarded to " + getActorRouterAddress(receiverAddrStr));
		}
    }

	// Do not edit this constructor.
	public ActorRouter() {
	}
	

	// methods to serialize and deserialize Message
	private ActorMessage messageToActorMessage(Message message){
		
		String signalID = message.getSignalID();
		Address sender = message.getSender();		
		
		String senderStr = sender.getSessionID().concat("-").concat(sender.getIP()).concat("-").concat(sender.getPort());
		
		Address receiver = message.getReceiver();
		String receiverStr = receiver.getSessionID().concat("-").concat(receiver.getIP()).concat("-").concat(receiver.getPort());
	
		ActorMessage actorMessage;
		
		// check if there is a payload to the message
		if(message.getPayload()!=null){
			String payloadStr = message.getPayload().toString();
			actorMessage = new ActorMessage(signalID+";"+senderStr+";"+receiverStr+";"+payloadStr);
		} else{
			actorMessage = new ActorMessage(signalID+";"+senderStr+";"+receiverStr);
		}
		
		return actorMessage;
	}
	

	private ForwardActorMessage messageToForwardActorMessage(Message message){
		
		String signalID = message.getSignalID();
		Address sender = message.getSender();		
		
		String senderStr = sender.getSessionID().concat("-").concat(sender.getIP()).concat("-").concat(sender.getPort());
		
		Address receiver = message.getReceiver();
		String receiverStr = receiver.getSessionID().concat("-").concat(receiver.getIP()).concat("-").concat(receiver.getPort());
	
		ForwardActorMessage actorMessage;
		
		// check if there is a payload to the message
		if(message.getPayload()!=null){
			String payloadStr = message.getPayload().toString();
			actorMessage = new ForwardActorMessage(signalID+";"+senderStr+";"+receiverStr+";"+payloadStr);
		} else{
			actorMessage = new ForwardActorMessage(signalID+";"+senderStr+";"+receiverStr);
		}
		
		return actorMessage;
	}
	
	static private Message actorMessageToMessage(ActorMessage msg){
		
		String actorMsgStr = msg.message;
		
		String str[] = actorMsgStr.split(";");
		
		Address sender = new Address();
		String senderStr=str[1];
		sender.setSessionID(senderStr.split("-")[0]);
		sender.setIP(senderStr.split("-")[1]);
		sender.setPort(senderStr.split("-")[2]);
		
		Address receiver = new Address();
		String receiverStr=str[2];
		receiver.setSessionID(receiverStr.split("-")[0]);
		receiver.setIP(receiverStr.split("-")[1]);
		receiver.setPort(receiverStr.split("-")[2]);
		
		
		Message message = new Message(str[0]);
		message.setSender(sender);
		message.setReceiver(receiver);
		
		// check if there is a payload to the message
		if(str.length>=4){
			Object payload =str[3];
			message.setPayload(payload);
		}

		return message;
	}
	

}