package no.ntnu.item.arctis.library.swing.buttonarray;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import javax.swing.JButton;
import javax.swing.JFrame;

import no.ntnu.item.arctis.runtime.Block;

public class ButtonArray extends Block {

	private JFrame frame;
	private List<String> buttonTitles = new ArrayList<String>();
	// Instance parameter. Edit only in overview page.
	public final java.lang.String buttons;
	// Instance parameter. Edit only in overview page.
	public final java.lang.String title;
	// Instance parameter. Edit only in overview page.
	public final boolean vertical;

	public void show() {
		frame = new JFrame(title);
		StringTokenizer t = new StringTokenizer(buttons, ",");
		if (vertical) {
			frame.setLayout(new GridLayout(t.countTokens(), 1));
		} else {
			frame.setLayout(new GridLayout(1, t.countTokens()));
		}

		while (t.hasMoreTokens()) {
			String buttonText = t.nextToken().trim();
			final JButton button = new JButton();
			button.setText(buttonText);
			button.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					sendToBlock("PUSHED" + "_" + blockID, button.getText());
				}
			});
			frame.getContentPane().add(button);
		}

		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				sendToBlock("CLOSED" + "_" + blockID);
			}
		});

		frame.setVisible(true);
		frame.pack();
	}

	public void hide() {
		frame.setVisible(false);
	}

	public static void main(String[] args) {
		ButtonArray a = new ButtonArray("Button 1, Button 2, Button 3, Button 4", "Title", true);
		a.show();
	}

	// Do not edit this constructor.
	public ButtonArray(java.lang.String buttons, java.lang.String title, boolean vertical) {
		this.buttons = buttons;
		this.title = title;
		this.vertical = vertical;
	}

}