package no.ntnu.item.arctis.library.swing.loginmanager;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Collection;
import java.util.HashSet;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

import no.ntnu.item.arctis.library.objects.login.Credentials;
import no.ntnu.item.arctis.runtime.Block;

public class LoginManager extends Block {

	private boolean loggedIn = false;
	private JButton button;
	private JLabel statusLabel;
	public no.ntnu.item.arctis.library.objects.login.Credentials credentials;
	// Instance parameter. Edit only in overview page.
	public final java.lang.String windowTitle;

	public void openWindow() {
		JFrame frame = new JFrame(windowTitle);
		frame.setSize(600, 100);
		statusLabel = new JLabel("Not logged in");
		frame.getContentPane().add(statusLabel, BorderLayout.NORTH);
		button = new JButton("Login");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				button.setEnabled(false);
				if (loggedIn) {
					sendToBlock("LOGOFF");
				} else {
					sendToBlock("LOGIN");
				}
			}
		});
		frame.getContentPane().add(button, BorderLayout.SOUTH);
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				sendToBlock("CLOSE");
			}
		});
		frame.setVisible(true);
	}

	public void loggedOn(Credentials c) {
		button.setEnabled(true);
		button.setText("Logout");
		statusLabel.setText("Logged in as " + c.getUserName());

		loggedIn = true;
	}

	public void loggedOff() {
		button.setEnabled(true);
		button.setText("Logon");
		statusLabel.setText("Not logged in");
		loggedIn = false;
	}

	// Do not edit this constructor.
	public LoginManager(java.lang.String windowTitle) {
		this.windowTitle = windowTitle;
	}

}
