package no.ntnu.item.arctis.library.lookup.a;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;

public class A implements IArctisBuildingBlock {

	public static final String LOOKUP_ADDRESS = "http://arctisregister.appspot.com/register";
	// public static final String LOOKUP_ADDRESS =
	// "http://localhost:8080/register";
	public static final String UTF_8 = "UTF-8";

	private String blockID;

	public void register() {

		final String key = blockID;
		
		final String address = AbstractRuntime.getRuntime(blockID).getMyAddress(blockID);

		try {
			// Construct data
			String query = URLEncoder.encode("key", UTF_8) + "=" + URLEncoder.encode(key, UTF_8) + "&" + URLEncoder.encode("value", UTF_8) + "="
					+ URLEncoder.encode(address, UTF_8);

			System.out.println("Data: " + query);

			// Send data
			URL url = new URL(LOOKUP_ADDRESS + "?" + query);
			URLConnection conn = url.openConnection();

			// Get the response
			BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
			String line;
			while ((line = rd.readLine()) != null) {
				System.out.println(line);
			}
			AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "REGISTER_OK_" + blockID);
			rd.close();
		} catch (UnsupportedEncodingException e) {
			AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "REGISTER_FAILED_" + blockID);
			e.printStackTrace();
		} catch (MalformedURLException e) {
			AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "REGISTER_FAILED_" + blockID);
			e.printStackTrace();
		} catch (IOException e) {
			AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "REGISTER_FAILED_" + blockID);
			e.printStackTrace();
		}
	}

	public void setBlockID(String blockID) {
		this.blockID = blockID;
	}
}