package no.ntnu.item.arctis.library.lookup.b;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;

public class B implements IArctisBuildingBlock {

	public static final String LOOKUP_ADDRESS = "http://arctisregister.appspot.com/register";
	// public static final String LOOKUP_ADDRESS =
	// "http://localhost:8080/register";
	public static final String UTF_8 = "UTF-8";

	private String blockID;

	public void lookup() {
		Runnable r = new Runnable() {
			public void run() {
				String key = blockID;
				try {
					// Construct data
					String query = URLEncoder.encode("key", UTF_8) + "=" + URLEncoder.encode(key, UTF_8);
					System.out.println("Query: " + query);

					// Send data
					URL url = new URL(LOOKUP_ADDRESS + "?" + query);
					URLConnection conn = url.openConnection();

					// Get the response
					BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
					String result = rd.readLine();
					rd.close();

					if (result != null) {
						AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "LOOKUP_OK_" + blockID, result);
					} else {
						AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "LOOKUP_NULL_" + blockID, result);
					}
				} catch (UnsupportedEncodingException e) {
					AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "LOOKUP_FAILED_" + blockID);
				} catch (MalformedURLException e) {
					AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "LOOKUP_FAILED_" + blockID);
				} catch (IOException e) {
					AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "LOOKUP_FAILED_" + blockID);
				}
			}
		};
		Thread t = new Thread(r);
		t.start();
	}

	public void setBlockID(String blockID) {
		this.blockID = blockID;
	}
}