package no.ntnu.item.arctis.library.reactivebuffer;

import java.util.ArrayList;

import no.ntnu.item.arctis.runtime.Block;

public class ReactiveBuffer<Item> extends Block {

	public java.util.List<Item> buffer;
	// Parameter defined by UML. Do not edit.
	public final boolean allowDuplicates;

	public boolean bufferIsEmpty() {
		return buffer.size() <= 1;
	}

	public void addToBuffer(Item o) {
		if (allowDuplicates || !buffer.contains(o)) {
			buffer.add(o);
		}
	}

	public Item getFromBuffer() {
		return buffer.remove(0);
	}

	public void initBuffer() {
		buffer = new ArrayList<Item>();
	}

	// Do not edit this constructor.
	public ReactiveBuffer(boolean allowDuplicates) {
		this.allowDuplicates = allowDuplicates;
	}
}